﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_driver.h
*  Create Date: 23/08/18
*  Description: eCPRI Driver Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_DRIVER_H_
#define _ECPRI_DRIVER_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ucp_js_subcrg.h"
#include "ucp_param.h"
#include "ecpri_comm.h"
#include "ecpri_pma.h"
#include "ecpri_roec.h"
#include "ecpri_switch.h"
#include "ecpri_timer.h"
#include "hw_cpri.h"
#include "phy_para.h"


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
/* eCPRI init */
void ecpri_init(uint32_t ecpri_option);
/* CPRI mode of eCPRI init */
void ecpri_cprimode_init(void);
/* eCPRI clock init */
void ecpri_clk_init(uint32_t ecpri_option);
/* eCPRI IP init */
void ecpri_ip_init(uint32_t ecpri_option);
/* eCPRI IP reconfig */
void ecpri_ip_recfg(void);
/* eCPRI antenna config */
int32_t ecpri_ant_cfg(uint8_t ant_id, uint8_t slot_type, uint8_t sym_id, uint32_t pkt_addr, uint16_t pkt_len);
/* eCPRI link status check */
bool ecpri_link_status_get(void);
/* eCPRI link status check */
void ecpri_link_status_check(void);


#endif /* _ECPRI_DRIVER_H_ */

