﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_pma.h
*  Create Date: 23/08/18
*  Description: eCPRI PMA Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_PMA_H_
#define _ECPRI_PMA_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include <stdbool.h>
#include "ucp_js_subcrg.h"
#include "ucp_pma.h"
#include "ucp_js_ctrl.h"
#include "ucp_utility.h"
#include "ucp_drv_common.h"
#include "phy_para.h"
#include "ecpri_comm.h"


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */
/* eCPRI PMA detect number & threshold */
#define ECPRI_PMA_DET_NUM                       10
#define ECPRI_PMA_DET_THR                       8


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
extern DDR0 uint32_t pma_fw[16384*2];

/* eCPRI PMA reset */
void ecpri_pma_rst(void);
/* eCPRI PMA common config */
void ecpri_pma_cfg(uint32_t ecpri_option);
/* eCPRI PMA init */
void ecpri_pma_init(uint32_t ecpri_option);
/* eCPRI PMA RX/TX init */
void ecpri_pma_rxtx_init(uint32_t ecpri_option);
/* eCPRI PMA RX adapt */
void ecpri_pma_rx_adapt(void);
/* eCPRI PMA link status get */
bool ecpri_pma_link_status_get(void);


#endif /* _ECPRI_PMA_H_ */

