﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_roec.h
*  Create Date: 23/08/18
*  Description: eCPRI ROEC Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_ROEC_H_
#define _ECPRI_ROEC_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ucp_ecpri.h"
#include "ucp_param.h"
#include "ucp_utility.h"
#include "ecpri_comm.h"


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */
/* eCPRI descriptor shift enumeration */
typedef enum EcpriDescShift
{
    E_DESC_SHIFT_128B = 0,                      /* 96Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_256B,                          /* 224Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_512B,                          /* 480Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_1KB,                           /* 992Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_2KB,                           /* 2016Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_4KB,                           /* 4064Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_8KB,                           /* 8160Byte + 32Byte(descriptor) */
    E_DESC_SHIFT_16KB                           /* 16352Byte + 32Byte(descriptor) */
} EcpriDescShift_e;


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
/* eCPRI ROEC init */
void ecpri_roec_init(void);


#endif /* _ECPRI_ROEC_H_ */

