﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_roec.s.c
*  Create Date: 23/08/18
*  Description: eCPRI ROEC Module Source File
*  Change History: 
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/18        1.0       Build this module
**********************************************************************************************************************/


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ecpri_roec.h"


/* --------------------------------------------------- <VAR DEF> --------------------------------------------------- */


/* -------------------------------------------------- <FUNC DEF> --------------------------------------------------- */
/**********************************************************************************************************************
*  Function: ecpri_roec_init
*  Description: eCPRI ROEC init
*  Input: none
*  Output: none
*  Return: none
*  Others: none
**********************************************************************************************************************/
void ecpri_roec_init(void)
{
    /* config address range for descriptor */
    do_write(&DESC_BEGIN_ADDR_2, ECPRI_RX_BUF_ADDR / ECPRI_DESC_ADDR_UNIT);
    do_write(&DESC_END_ADDR_2, (ECPRI_RX_BUF_ADDR + ECPRI_RX_BUF_SIZE) / ECPRI_DESC_ADDR_UNIT);

    /* config next valid address for descriptor */
    do_write(&DESC_TAIL_ADDR_2, (ECPRI_RX_BUF_ADDR + ECPRI_RX_BUF_SIZE) / ECPRI_DESC_ADDR_UNIT);

    /* config descriptor shift */
    do_write(&DESC_SHIFT_2, (uint32_t)E_DESC_SHIFT_16KB);

    /* config pointer update interval for descriptor */
    do_write(&DESC_PTR_CNT_2, 4);

    /* descriptor work start */
    do_write(&DESC_START_2, BIT0);

    /* roe_ctrl module enable */
    do_write(&ROEC_ENABLE, BIT0);
}



