/*
*********************************************************************************************************
*                                               uC/OS-II
*                                        The Real-Time Kernel
*
*                            (c) Copyright 2003, Micrium, Inc., Weston, FL
*                                          All Rights Reserved
*
* File    : OS_CPU.H
* By      : Ahmed Faiz
* Created : 2008/02/12
*********************************************************************************************************
*/

#if !defined(OS_CPU_H)
#define OS_CPU_H    

#define _LANGUAGE_C //ducx
#include <ucps2-intrin.h>

/*
*********************************************************************************************************
*                                            GLOBAL DEFINES
*********************************************************************************************************
*/
#if ( defined(_LANGUAGE_ASM) || defined(_LANGUAGE_C))
/* NESTED & NOT_NESTED Defines for interrupts routines */  
#define  NESTED               1                         
#define  NOT_NESTED           0

#endif 

#if defined(_LANGUAGE_C)

#ifdef   OS_CPU_GLOBALS
#define  OS_CPU_EXT
#else
#define  OS_CPU_EXT  extern
#endif

#define  OS_STK_GROWTH        1                 /* Stack grows from HIGH to LOW memory on SPU     */
#define  OS_CRITICAL_METHOD   3

extern void ucp_enter_critical(void);
extern void ucp_exit_critical(void);

/*
*********************************************************************************************************
*                                            GLOBAL MACROS
*********************************************************************************************************
*/
#define  OS_ENTER_CRITICAL()   ucp_enter_critical()
#define  OS_EXIT_CRITICAL()    ucp_exit_critical()


/*
*********************************************************************************************************
*                                              DATA TYPES
*                                         (Compiler Specific)
*********************************************************************************************************
*/


typedef unsigned int    BOOLEAN;    /* Unsigned  8 bit quantity                                        */
typedef unsigned char   INT8U;      /* Unsigned  8 bit quantity                                        */
typedef signed   char   INT8S;      /* Signed    8 bit quantity                                        */
typedef unsigned short  INT16U;     /* Unsigned 16 bit quantity                                        */
typedef signed   short  INT16S;     /* Signed   16 bit quantity                                        */
typedef unsigned int    INT32U;     /* Unsigned 32 bit quantity                                        */
typedef signed   int    INT32S;     /* Signed   32 bit quantity                                        */
typedef float           FP32;       /* Single precision floating point                                 */
typedef double          FP64;       /* Double precision floating point                                 */

typedef unsigned int    OS_STK;     /* Each stack entry is 32-bit wide                                 */
typedef unsigned int    OS_CPU_SR;  /* Define size of CPU status register                              */										

#endif   /* _LANGUAGE_C */
#endif /* OS_CPU_H */

