﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_test.h
*  Create Date: 23/08/21
*  Description: eCPRI Test Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/21        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_TEST_H_
#define _ECPRI_TEST_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "typedef.h"
#include "ucp_utility.h"
#include "ucp_printf.h"
#include "ecpri_comm.h"

#ifdef ECS_RFM0
#include "ecpri_csu.h"
#endif


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */
/* eCPRI test result structure */
typedef struct EcpriTestResult
{
    uint32_t test_times;                        /* test times */
    uint32_t succ_times;                        /* success times */
    uint32_t fail_times;                        /* fail times */
} EcpriTestResult_t;


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
/* fronthaul data init */
int32_t fh_data_init(void);
/* fronthaul driver init */
int32_t fh_drv_init(void);
/* fronthaul CSU test init */
int32_t fh_csu_test_init(void);
#ifdef ECS_RFM0
/* eCPRI test PL packet process */
extern void ecpri_test_pl_pkt_proc(uint32_t pkt_addr, uint16_t pkt_len);
#endif
/* fronthaul data check */
void fh_data_check(uint32_t times);
/* fronthaul test case */
void fh_test_case(void);


#endif /* _ECPRI_TEST_H_ */

