﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_test_case100.h
*  Create Date: 23/08/23
*  Description: eCPRI Test Case100 Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      23/08/23        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_TEST_CASE100_H_
#define _ECPRI_TEST_CASE100_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ecpri_test.h"

#ifdef ECS_RFM0
#include "ecpri_csu.h"
#endif

#ifdef ECS_RFM1
#include "ecpri_driver.h"
#endif


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */
/* eCPRI loopback test result structure */
typedef struct EcpriLBTestResult
{
    EcpriTestResult_t pl_stat;                  /* PL statistic */
} EcpriLBTestResult_t;


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
#ifdef ECS_RFM0
/* eCPRI test ECS_RFM0 init */
void ecpri_test_ecs0_init(void);
/* eCPRI test PL packet process */
void ecpri_test_pl_pkt_proc(uint32_t pkt_addr, uint16_t pkt_len);
/* eCPRI test ECS_RFM0 status check */
void ecpri_test_ecs0_status_check(void);
/* eCPRI test ECS_RFM0 result update */
void ecpri_test_ecs0_result_update(void);
#endif
#ifdef ECS_RFM1
/* eCPRI test ECS_RFM1 init */
void ecpri_test_ecs1_init(void);
#endif


#endif /* _ECPRI_TEST_CASE100_H_ */

