﻿/**********************************************************************************************************************
*  Copyright (C), 2022-2026, SMARTLOGIC TECHNOLOGY LTD.
*  File Name: ecpri_test_case109.h
*  Create Date: 24/03/05
*  Description: eCPRI Test Case109 Module Header File
*  Change History:
*      <author>      <time>      <version>   <desc>
*    1. ShangH      24/03/05        1.0       Build this module
**********************************************************************************************************************/

#ifndef _ECPRI_TEST_CASE109_H_
#define _ECPRI_TEST_CASE109_H_


/* -------------------------------------------------- <INC FILE> --------------------------------------------------- */
#include "ecpri_test.h"
#include "ucp_drv_common.h"

#ifdef ECS_RFM0
#include "ecpri_irq.h"
#include "ecpri_csu.h"
#endif

#ifdef ECS_RFM1
#include "ecpri_test_case109_antdata.h"
#include "ecpri_driver.h"
#endif


/* -------------------------------------------------- <MACRO DEF> -------------------------------------------------- */
/* eCPRI test SM address & size(48KB) */
#define ECPRI_TEST_SM_ADDR                      0x0A4F4000ul
#define ECPRI_TEST_SM_SIZE                      0x0000C000ul


/* -------------------------------------------------- <TYPE DEF> --------------------------------------------------- */


/* --------------------------------------------------- <DECLARE> --------------------------------------------------- */
#ifdef ECS_RFM0
/* eCPRI test ECS_RFM0 init */
void ecpri_test_ecs0_init(void);
/* eCPRI test PL packet process */
void ecpri_test_pl_pkt_proc(uint32_t pkt_addr, uint16_t pkt_len);
/* eCPRI test ECS_RFM0 status check */
void ecpri_test_ecs0_status_check(void);
/* eCPRI test ECS_RFM0 result update */
void ecpri_test_ecs0_result_update(void);
#endif
#ifdef ECS_RFM1
/* eCPRI test ECS_RFM1 init */
void ecpri_test_ecs1_init(void);
/* eCPRI test ECS_RFM1 status check */
void ecpri_test_ecs1_status_check(void);
/* eCPRI test ECS_RFM1 result update */
void ecpri_test_ecs1_result_update(void);
#endif


#endif /* _ECPRI_TEST_CASE109_H_ */

