/*********************************************************************
 *
 *        Filename:  ucp_pma.h
 *
 *         Created:  2021-11-06 03:30:30 PM
 *   Last Modified:  2022-01-22 02:50:47 PM
 *          Author:  LiPin , lip2014@ia.ac.cn
 *    Organization:  Beijing Smart Logic Technology Co., Ltd.
 *
 *     Description:
 *
 *
 ********************************************************************/

#ifndef __PMA__
#define __PMA__

//The PMA Config Base Addr
#define JS_PMA0_CFG              0x05f74000
#define JECS_PMA1_CFG            0x08484000
#define PET_PMA3_CFG             0x09204000

//------------------------JS0 SUBSYSTEM -------------------------//
//The PMA Lane Config Base Addr
#define JS_PMA0_LANE0_BASE       JS_PMA0_CFG + 0x10000*4
#define JS_PMA0_LANE1_BASE       JS_PMA0_CFG + 0x10800*4
#define JS_PMA0_LANE2_BASE       JS_PMA0_CFG + 0x11000*4
#define JS_PMA0_LANE3_BASE       JS_PMA0_CFG + 0x11800*4
#define JS_PMA0_BROADCAST_BASE   JS_PMA0_CFG + 0x12000*4
//The PMA COMMON Base Addr
#define JS_PMA0_COMMON_BASE      JS_PMA0_CFG + 0x14000*4

//The PMA PCS Addr
#define JS_PMA0_PCS_BASE         JS_PMA0_CFG + 0x18000*4

//The PMA Lane Config Register
#define JS_PMA0_LANE0_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x01)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x02)))            //Attributes : RO
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x03)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x07)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x08)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x09)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x0A)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x0B)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x10)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x11)))            //Attributes : RO
#define JS_PMA0_LANE0_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x12)))            //Attributes : RO
#define JS_PMA0_LANE0_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x13)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x14)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x20)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x21)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x23)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x24)))            //Attributes : RO
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x25)))            //Attributes : RO
#define JS_PMA0_LANE0_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x26)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_RESET                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x30)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x31)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x32)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x40)))            //Attributes : RW
#define JS_PMA0_LANE0_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x41)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x50)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x51)))            //Attributes : RO
#define JS_PMA0_LANE0_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x52)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x53)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x55)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x60)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x61)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x62)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x63)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x70)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x71)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x72)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x80)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x81)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x82)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x83)))            //Attributes : RW
#define JS_PMA0_LANE0_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x90)))            //Attributes : RW
#define JS_PMA0_LANE0_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x91)))            //Attributes : RW
#define JS_PMA0_LANE0_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x92)))            //Attributes : RW
#define JS_PMA0_LANE0_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x93)))            //Attributes : RW
#define JS_PMA0_LANE0_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x94)))            //Attributes : RW
#define JS_PMA0_LANE0_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xA0)))            //Attributes : RW
#define JS_PMA0_LANE0_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xB0)))            //Attributes : RW
#define JS_PMA0_LANE0_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xB1)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC0)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_DCC_CTRL                             (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC1)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC2)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC3)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC4)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC5)))            //Attributes : RO
#define JS_PMA0_LANE0_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC6)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC8)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xC9)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xCA)))            //Attributes : RW
#define JS_PMA0_LANE0_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xCB)))            //Attributes : RW
#define JS_PMA0_LANE0_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xCC)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD0)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD1)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD2)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD3)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD4)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD5)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD6)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD7)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD8)))            //Attributes : RW
#define JS_PMA0_LANE0_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xD9)))            //Attributes : RO
#define JS_PMA0_LANE0_PLL_STATE_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xDA)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_VALID_PHY                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xDF)))            //Attributes : RO
#define JS_PMA0_LANE0_RX_VALID_MUX                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE0)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE1)))            //Attributes : RW
#define JS_PMA0_LANE0_SRIO_DEGRADED                           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE2)))            //Attributes : RW
#define JS_PMA0_LANE0_SRIO_RETRAIN                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE3)))            //Attributes : RW
#define JS_PMA0_LANE0_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE4)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_INIT_C0                              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE5)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_INIT_CN1                             (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE6)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_INIT_CP1                             (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE7)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE8)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xE9)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xEA)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xEB)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xEC)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xED)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xEE)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xEF)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF0)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF1)))            //Attributes : RW
#define JS_PMA0_LANE0_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF2)))            //Attributes : RO
#define JS_PMA0_LANE0_EQ_FSM                                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF3)))            //Attributes : RO
#define JS_PMA0_LANE0_ETH_RX_LOS                              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF4)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_PRESET_C0                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF5)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF6)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF7)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xF8)))            //Attributes : RW
#define JS_PMA0_LANE0_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0xff)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x108)))            //Attributes : RW
#define JS_PMA0_LANE0_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x10D)))            //Attributes : RW
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x118)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x11D)))            //Attributes : RW
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x128)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x12D)))            //Attributes : RW
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x138)))            //Attributes : RW
#define JS_PMA0_LANE0_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE0_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE0_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE0_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE0_BASE + 4*0x13D)))            //Attributes : RW

#define JS_PMA0_LANE1_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x01)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x02)))            //Attributes : RO
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x03)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x07)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x08)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x09)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x0A)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x0B)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x10)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x11)))            //Attributes : RO
#define JS_PMA0_LANE1_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x12)))            //Attributes : RO
#define JS_PMA0_LANE1_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x13)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x14)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x20)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x21)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x23)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x24)))            //Attributes : RO
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x25)))            //Attributes : RO
#define JS_PMA0_LANE1_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x26)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_RESET                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x30)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x31)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x32)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x40)))            //Attributes : RW
#define JS_PMA0_LANE1_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x41)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x50)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x51)))            //Attributes : RO
#define JS_PMA0_LANE1_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x52)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x53)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x55)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x60)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x61)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x62)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x63)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x70)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x71)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x72)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x80)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x81)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x82)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x83)))            //Attributes : RW
#define JS_PMA0_LANE1_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x90)))            //Attributes : RW
#define JS_PMA0_LANE1_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x91)))            //Attributes : RW
#define JS_PMA0_LANE1_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x92)))            //Attributes : RW
#define JS_PMA0_LANE1_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x93)))            //Attributes : RW
#define JS_PMA0_LANE1_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x94)))            //Attributes : RW
#define JS_PMA0_LANE1_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xA0)))            //Attributes : RW
#define JS_PMA0_LANE1_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xB0)))            //Attributes : RW
#define JS_PMA0_LANE1_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xB1)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC0)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_DCC_CTRL                             (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC1)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC2)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC3)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC4)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC5)))            //Attributes : RO
#define JS_PMA0_LANE1_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC6)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC8)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xC9)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xCA)))            //Attributes : RW
#define JS_PMA0_LANE1_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xCB)))            //Attributes : RW
#define JS_PMA0_LANE1_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xCC)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD0)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD1)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD2)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD3)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD4)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD5)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD6)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD7)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD8)))            //Attributes : RW
#define JS_PMA0_LANE1_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xD9)))            //Attributes : RO
#define JS_PMA0_LANE1_PLL_STATE_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xDA)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_VALID_PHY                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xDF)))            //Attributes : RO
#define JS_PMA0_LANE1_RX_VALID_MUX                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE0)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE1)))            //Attributes : RW
#define JS_PMA0_LANE1_SRIO_DEGRADED                           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE2)))            //Attributes : RW
#define JS_PMA0_LANE1_SRIO_RETRAIN                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE3)))            //Attributes : RW
#define JS_PMA0_LANE1_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE4)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_INIT_C0                              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE5)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_INIT_CN1                             (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE6)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_INIT_CP1                             (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE7)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE8)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xE9)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xEA)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xEB)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xEC)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xED)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xEE)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xEF)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF0)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF1)))            //Attributes : RW
#define JS_PMA0_LANE1_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF2)))            //Attributes : RO
#define JS_PMA0_LANE1_EQ_FSM                                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF3)))            //Attributes : RO
#define JS_PMA0_LANE1_ETH_RX_LOS                              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF4)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_PRESET_C0                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF5)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF6)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF7)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xF8)))            //Attributes : RW
#define JS_PMA0_LANE1_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0xff)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x108)))            //Attributes : RW
#define JS_PMA0_LANE1_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x10D)))            //Attributes : RW
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x118)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x11D)))            //Attributes : RW
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x128)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x12D)))            //Attributes : RW
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x138)))            //Attributes : RW
#define JS_PMA0_LANE1_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE1_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE1_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE1_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE1_BASE + 4*0x13D)))            //Attributes : RW

#define JS_PMA0_LANE2_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x01)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x02)))            //Attributes : RO
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x03)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x07)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x08)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x09)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x0A)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x0B)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x10)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x11)))            //Attributes : RO
#define JS_PMA0_LANE2_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x12)))            //Attributes : RO
#define JS_PMA0_LANE2_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x13)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x14)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x20)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x21)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x23)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x24)))            //Attributes : RO
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x25)))            //Attributes : RO
#define JS_PMA0_LANE2_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x26)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_RESET                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x30)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x31)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x32)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x40)))            //Attributes : RW
#define JS_PMA0_LANE2_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x41)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x50)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x51)))            //Attributes : RO
#define JS_PMA0_LANE2_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x52)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x53)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x55)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x60)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x61)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x62)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x63)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x70)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x71)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x72)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x80)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x81)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x82)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x83)))            //Attributes : RW
#define JS_PMA0_LANE2_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x90)))            //Attributes : RW
#define JS_PMA0_LANE2_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x91)))            //Attributes : RW
#define JS_PMA0_LANE2_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x92)))            //Attributes : RW
#define JS_PMA0_LANE2_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x93)))            //Attributes : RW
#define JS_PMA0_LANE2_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x94)))            //Attributes : RW
#define JS_PMA0_LANE2_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xA0)))            //Attributes : RW
#define JS_PMA0_LANE2_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xB0)))            //Attributes : RW
#define JS_PMA0_LANE2_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xB1)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC0)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_DCC_CTRL                             (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC1)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC2)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC3)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC4)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC5)))            //Attributes : RO
#define JS_PMA0_LANE2_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC6)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC8)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xC9)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xCA)))            //Attributes : RW
#define JS_PMA0_LANE2_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xCB)))            //Attributes : RW
#define JS_PMA0_LANE2_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xCC)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD0)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD1)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD2)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD3)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD4)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD5)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD6)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD7)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD8)))            //Attributes : RW
#define JS_PMA0_LANE2_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xD9)))            //Attributes : RO
#define JS_PMA0_LANE2_PLL_STATE_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xDA)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_VALID_PHY                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xDF)))            //Attributes : RO
#define JS_PMA0_LANE2_RX_VALID_MUX                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE0)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE1)))            //Attributes : RW
#define JS_PMA0_LANE2_SRIO_DEGRADED                           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE2)))            //Attributes : RW
#define JS_PMA0_LANE2_SRIO_RETRAIN                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE3)))            //Attributes : RW
#define JS_PMA0_LANE2_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE4)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_INIT_C0                              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE5)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_INIT_CN1                             (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE6)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_INIT_CP1                             (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE7)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE8)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xE9)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xEA)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xEB)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xEC)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xED)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xEE)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xEF)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF0)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF1)))            //Attributes : RW
#define JS_PMA0_LANE2_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF2)))            //Attributes : RO
#define JS_PMA0_LANE2_EQ_FSM                                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF3)))            //Attributes : RO
#define JS_PMA0_LANE2_ETH_RX_LOS                              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF4)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_PRESET_C0                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF5)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF6)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF7)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xF8)))            //Attributes : RW
#define JS_PMA0_LANE2_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0xFF)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x108)))            //Attributes : RW
#define JS_PMA0_LANE2_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x10D)))            //Attributes : RW
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x118)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x11D)))            //Attributes : RW
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x128)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x12D)))            //Attributes : RW
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x138)))            //Attributes : RW
#define JS_PMA0_LANE2_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE2_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE2_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE2_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE2_BASE + 4*0x13D)))            //Attributes : RW

#define JS_PMA0_LANE3_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x01)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x02)))            //Attributes : RO
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x03)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x07)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x08)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x09)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x0A)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x0B)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x10)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x11)))            //Attributes : RO
#define JS_PMA0_LANE3_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x12)))            //Attributes : RO
#define JS_PMA0_LANE3_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x13)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x14)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x20)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x21)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x23)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x24)))            //Attributes : RO
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x25)))            //Attributes : RO
#define JS_PMA0_LANE3_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x26)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_RESET                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x30)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x31)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x32)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x40)))            //Attributes : RW
#define JS_PMA0_LANE3_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x41)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x50)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x51)))            //Attributes : RO
#define JS_PMA0_LANE3_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x52)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x53)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x55)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x60)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x61)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x62)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x63)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x70)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x71)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x72)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x80)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x81)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x82)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x83)))            //Attributes : RW
#define JS_PMA0_LANE3_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x90)))            //Attributes : RW
#define JS_PMA0_LANE3_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x91)))            //Attributes : RW
#define JS_PMA0_LANE3_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x92)))            //Attributes : RW
#define JS_PMA0_LANE3_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x93)))            //Attributes : RW
#define JS_PMA0_LANE3_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x94)))            //Attributes : RW
#define JS_PMA0_LANE3_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xA0)))            //Attributes : RW
#define JS_PMA0_LANE3_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xB0)))            //Attributes : RW
#define JS_PMA0_LANE3_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xB1)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC0)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_DCC_CTRL                             (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC1)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC2)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC3)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC4)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC5)))            //Attributes : RO
#define JS_PMA0_LANE3_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC6)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC8)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xC9)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xCA)))            //Attributes : RW
#define JS_PMA0_LANE3_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xCB)))            //Attributes : RW
#define JS_PMA0_LANE3_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xCC)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD0)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD1)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD2)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD3)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD4)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD5)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD6)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD7)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD8)))            //Attributes : RW
#define JS_PMA0_LANE3_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xD9)))            //Attributes : RO
#define JS_PMA0_LANE3_PLL_STATE_MUX                           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xDA)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_VALID_PHY                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xDF)))            //Attributes : RO
#define JS_PMA0_LANE3_RX_VALID_MUX                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE0)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE1)))            //Attributes : RW
#define JS_PMA0_LANE3_SRIO_DEGRADED                           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE2)))            //Attributes : RW
#define JS_PMA0_LANE3_SRIO_RETRAIN                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE3)))            //Attributes : RW
#define JS_PMA0_LANE3_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE4)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_INIT_C0                              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE5)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_INIT_CN1                             (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE6)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_INIT_CP1                             (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE7)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE8)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xE9)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xEA)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xEB)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xEC)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xED)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xEE)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xEF)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF0)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF1)))            //Attributes : RW
#define JS_PMA0_LANE3_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF2)))            //Attributes : RO
#define JS_PMA0_LANE3_EQ_FSM                                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF3)))            //Attributes : RO
#define JS_PMA0_LANE3_ETH_RX_LOS                              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF4)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_PRESET_C0                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF5)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF6)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF7)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xF8)))            //Attributes : RW
#define JS_PMA0_LANE3_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0xff)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x108)))            //Attributes : RW
#define JS_PMA0_LANE3_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x10D)))            //Attributes : RW
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x118)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x11D)))            //Attributes : RW
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x128)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x12D)))            //Attributes : RW
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x138)))            //Attributes : RW
#define JS_PMA0_LANE3_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JS_PMA0_LANE3_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JS_PMA0_LANE3_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JS_PMA0_LANE3_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JS_PMA0_LANE3_BASE + 4*0x13D)))            //Attributes : RW

#define JS_PMA0_BROADCAST_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x01)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x02)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x03)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x07)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x08)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x09)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x0A)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x0B)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x10)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x11)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x12)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x13)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x14)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x20)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x21)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x23)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x24)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x25)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x26)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_RESET                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x30)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x31)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x32)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x40)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x41)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x50)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x51)))            //Attributes : RO
#define JS_PMA0_BROADCAST_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x52)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x53)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x55)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x60)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x61)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x62)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x63)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x70)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x71)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x72)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x80)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x81)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x82)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x83)))            //Attributes : RW
#define JS_PMA0_BROADCAST_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x90)))            //Attributes : RW
#define JS_PMA0_BROADCAST_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x91)))            //Attributes : RW
#define JS_PMA0_BROADCAST_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x92)))            //Attributes : RW
#define JS_PMA0_BROADCAST_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x93)))            //Attributes : RW
#define JS_PMA0_BROADCAST_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x94)))            //Attributes : RW
#define JS_PMA0_BROADCAST_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xA0)))            //Attributes : RW
#define JS_PMA0_BROADCAST_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xB0)))            //Attributes : RW
#define JS_PMA0_BROADCAST_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xB1)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC0)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_DCC_CTRL                             (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC1)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC2)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC3)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC4)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC5)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC6)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC8)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xC9)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xCA)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xCB)))            //Attributes : RW
#define JS_PMA0_BROADCAST_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xCC)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD0)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD1)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD2)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD3)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD4)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD5)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD6)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD7)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD8)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xD9)))            //Attributes : RO
#define JS_PMA0_BROADCAST_PLL_STATE_MUX                           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xDA)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_VALID_PHY                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xDF)))            //Attributes : RO
#define JS_PMA0_BROADCAST_RX_VALID_MUX                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE0)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE1)))            //Attributes : RW
#define JS_PMA0_BROADCAST_SRIO_DEGRADED                           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE2)))            //Attributes : RW
#define JS_PMA0_BROADCAST_SRIO_RETRAIN                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE3)))            //Attributes : RW
#define JS_PMA0_BROADCAST_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE4)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_INIT_C0                              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE5)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_INIT_CN1                             (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE6)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_INIT_CP1                             (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE7)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE8)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xE9)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xEA)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xEB)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xEC)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xED)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xEE)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xEF)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF0)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF1)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF2)))            //Attributes : RO
#define JS_PMA0_BROADCAST_EQ_FSM                                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF3)))            //Attributes : RO
#define JS_PMA0_BROADCAST_ETH_RX_LOS                              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF4)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_PRESET_C0                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF5)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF6)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF7)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xF8)))            //Attributes : RW
#define JS_PMA0_BROADCAST_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0xff)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x108)))            //Attributes : RW
#define JS_PMA0_BROADCAST_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x10D)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x118)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x11D)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x128)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x12D)))            //Attributes : RW
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x138)))            //Attributes : RW
#define JS_PMA0_BROADCAST_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JS_PMA0_BROADCAST_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JS_PMA0_BROADCAST_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JS_PMA0_BROADCAST_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JS_PMA0_BROADCAST_BASE + 4*0x13D)))            //Attributes : RW

//The PMA COMMON Register
#define JS_PMA0_MPLLA_PARAM1                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_MPLLA_PARAM2                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x01)))            //Attributes : RW
#define JS_PMA0_MPLLA_PARAM3                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x02)))            //Attributes : RW
#define JS_PMA0_MPLLA_PARAM4                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x03)))            //Attributes : RW
#define JS_PMA0_MPLLA_PARAM5                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_MPLLA_PARAM6                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_MPLLA_FORCE_EN              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_MPLLA_FORCE_ACK             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x07)))            //Attributes : RO
#define JS_PMA0_MPLLB_PARAM1                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x08)))            //Attributes : RW
#define JS_PMA0_MPLLB_PARAM2                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x09)))            //Attributes : RW
#define JS_PMA0_MPLLB_PARAM3                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x0A)))            //Attributes : RW
#define JS_PMA0_MPLLB_PARAM4                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x0B)))            //Attributes : RW
#define JS_PMA0_MPLLB_PARAM5                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x0C)))            //Attributes : RW
#define JS_PMA0_MPLLB_PARAM6                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x0D)))            //Attributes : RW
#define JS_PMA0_MPLLB_FORCE_EN              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x0E)))            //Attributes : RW
#define JS_PMA0_MPLLB_FORCE_ACK             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x0F)))            //Attributes : RO
#define JS_PMA0_SUP_MISC                    (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x16)))            //Attributes : RW
#define JS_PMA0_MPLLA_FRAC_CTRL1            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x17)))            //Attributes : RW
#define JS_PMA0_MPLLA_FRAC_CTRL2            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x18)))            //Attributes : RW
#define JS_PMA0_MPLLA_FRAC_CTRL3            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x19)))            //Attributes : RW
#define JS_PMA0_MPLLA_FRAC_CTRL4            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x1A)))            //Attributes : RW
#define JS_PMA0_MPLLA_SSC_CTRL1             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x1B)))            //Attributes : RW
#define JS_PMA0_MPLLA_SSC_CTRL2             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x1C)))            //Attributes : RW_EXT_L
#define JS_PMA0_MPLLA_SSC_CTRL3             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x1D)))            //Attributes : RW_EXT_H
#define JS_PMA0_MPLLA_SSC_CTRL4             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x1E)))            //Attributes : RW
#define JS_PMA0_MPLLA_SSC_CTRL5             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x1F)))            //Attributes : RW_EXT_L
#define JS_PMA0_MPLLA_SSC_CTRL6             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x20)))            //Attributes : RW_EXT_H
#define JS_PMA0_MPLLB_FRAC_CTRL1            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x21)))            //Attributes : RW
#define JS_PMA0_MPLLB_FRAC_CTRL2            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_MPLLB_FRAC_CTRL3            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x23)))            //Attributes : RW
#define JS_PMA0_MPLLB_FRAC_CTRL4            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x24)))            //Attributes : RW
#define JS_PMA0_MPLLB_SSC_CTRL1             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x25)))            //Attributes : RW
#define JS_PMA0_MPLLB_SSC_CTRL2             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x26)))            //Attributes : RW_EXT_L
#define JS_PMA0_MPLLB_SSC_CTRL3             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x27)))            //Attributes : RW_EXT_H
#define JS_PMA0_MPLLB_SSC_CTRL4             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x28)))            //Attributes : RW
#define JS_PMA0_MPLLB_SSC_CTRL5             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x29)))            //Attributes : RW_EXT_L
#define JS_PMA0_MPLLB_SSC_CTRL6             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x2A)))            //Attributes : RW_EXT_H
#define JS_PMA0_MPLLA_RECAL_CTRL            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x2B)))            //Attributes : RW
#define JS_PMA0_MPLLB_RECAL_CTRL            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x2C)))            //Attributes : RW
#define JS_PMA0_MPLL_CTRL_MUX               (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x2D)))            //Attributes : RW
#define JS_PMA0_POWER_SUPPLY_SEL            (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x30)))            //Attributes : RW
#define JS_PMA0_PHY_RESET                   (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x31)))            //Attributes : RW
#define JS_PMA0_REF_CLK_CTRL                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x40)))            //Attributes : RW
#define JS_PMA0_REFA_CLK_CTRL1              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x41)))            //Attributes : RW
#define JS_PMA0_REFA_CLK_CTRL2              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x42)))            //Attributes : RW
#define JS_PMA0_REFA_CLK_STATUS             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x43)))            //Attributes : RO
#define JS_PMA0_REFB_CLK_CTRL1              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x44)))            //Attributes : RW
#define JS_PMA0_REFB_CLK_CTRL2              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x45)))            //Attributes : RW
#define JS_PMA0_REFB_CLK_STATUS             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x46)))            //Attributes : RO
#define JS_PMA0_REF_CLK_MUX                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x47)))            //Attributes : RW
#define JS_PMA0_RES_ACK_IN                  (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x50)))            //Attributes : RW
#define JS_PMA0_RES_ACK_OUT                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x51)))            //Attributes : RO
#define JS_PMA0_RES_REQ_IN                  (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x52)))            //Attributes : RW
#define JS_PMA0_RES_REQ_OUT                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x53)))            //Attributes : RO
#define JS_PMA0_RTUNE_REQ                   (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x54)))            //Attributes : RW
#define JS_PMA0_RTUNE_ACK                   (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x55)))            //Attributes : RO
#define JS_PMA0_RTUNE_CTRL1                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x56)))            //Attributes : RW
#define JS_PMA0_RTUNE_CTRL2                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x57)))            //Attributes : RW
#define JS_PMA0_RTUNE_CTRL3                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x58)))            //Attributes : RW
#define JS_PMA0_RX_BIAS_CURRENT_CTRL        (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x59)))            //Attributes : RW
#define JS_PMA0_CR_PARA_SEL                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x90)))            //Attributes : RW
#define JS_PMA0_POWER_GATING_SIGNAL1        (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x60)))            //Attributes : RW
#define JS_PMA0_POWER_GATING_SIGNAL2        (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x61)))            //Attributes : RO
#define JS_PMA0_POWER_GATING_SIGNAL3        (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x62)))            //Attributes : RW
#define JS_PMA0_SRAM_CTRL                   (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x68)))            //Attributes : RW
#define JS_PMA0_SRAM_STATUS                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x69)))            //Attributes : RO
#define JS_PMA0_SRIO_RST_REQ                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x6A)))            //Attributes : RO
#define JS_PMA0_SRIO_GEN3_EN                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x6C)))            //Attributes : RW
#define JS_PMA0_SRIO_RATE_OUT               (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x6D)))            //Attributes : RW
#define JS_PMA0_CPRI_RST_REQ                (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x70)))            //Attributes : RW
#define JS_PMA0_CPRI_RX_LOS                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x71)))            //Attributes : RW
#define JS_PMA0_CPRI_SIGNAL_OK              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x72)))            //Attributes : RW
#define JS_PMA0_CPRI_ENERGY_DET             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x73)))            //Attributes : RW
#define JS_PMA0_CPRI_SIGDET                 (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x74)))            //Attributes : RW
#define JS_PMA0_CPRI_PCS_STATUS             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x75)))            //Attributes : RO
#define JS_PMA0_CPRI_PCS_STATUS_CTRL        (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x76)))            //Attributes : RW
#define JS_PMA0_ETH_ENERGY_DET              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x80)))            //Attributes : RW
#define JS_PMA0_ETH_SPEED_CTRL              (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0x81)))            //Attributes : RO
#define JS_PMA0_TX_CLK_SEL                  (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0xF0)))            //Attributes : RW
#define JS_PMA0_RPCS_TX_CLK_SEL             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0xF1)))            //Attributes : RW
#define JS_PMA0_RPCS_RX_CLK_SEL             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0xF2)))            //Attributes : RW
#define JS_PMA0_PMA_COM_SCRATCH             (*((volatile uint32_t *)(JS_PMA0_COMMON_BASE + 4*0xff)))            //Attributes : RW

//The PMA PCS Register
#define JS_PMA0_PCS_SOFT_RESET              (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x00)))            //Attributes : RW
#define JS_PMA0_PCS_LOOPBACK_CTRL           (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x04)))            //Attributes : RW
#define JS_PMA0_PCS_PRBS_UDP_SEND           (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x05)))            //Attributes : RW
#define JS_PMA0_PCS_PRBS_SEND_ERRINS        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x06)))            //Attributes : RW
#define JS_PMA0_PCS_TXUDP_0                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x07)))            //Attributes : RW_EXT_L
#define JS_PMA0_PCS_TXUDP_1                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x08)))            //Attributes : RW_EXT
#define JS_PMA0_PCS_TXUDP_2                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x09)))            //Attributes : RW_EXT
#define JS_PMA0_PCS_TXUDP_3                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x0A)))            //Attributes : RW_EXT
#define JS_PMA0_PCS_TXUDP_4                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x0B)))            //Attributes : RW_EXT_H
#define JS_PMA0_PCS_PRBS_UDP_CHK            (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x10)))            //Attributes : RW
#define JS_PMA0_PCS_RXUDP_0                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x11)))            //Attributes : RW_EXT_L
#define JS_PMA0_PCS_RXUDP_1                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x12)))            //Attributes : RW_EXT
#define JS_PMA0_PCS_RXUDP_2                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x13)))            //Attributes : RW_EXT
#define JS_PMA0_PCS_RXUDP_3                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x14)))            //Attributes : RW_EXT
#define JS_PMA0_PCS_RXUDP_4                 (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x15)))            //Attributes : RW_EXT_H
#define JS_PMA0_PCS_RXPRBS_ERRCNT_L0        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x16)))            //Attributes : RO
#define JS_PMA0_PCS_RXPRBS_ERRCNT_L1        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x17)))            //Attributes : RO
#define JS_PMA0_PCS_RXPRBS_ERRCNT_L2        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x18)))            //Attributes : RO
#define JS_PMA0_PCS_RXPRBS_ERRCNT_L3        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x19)))            //Attributes : RO
#define JS_PMA0_PCS_NELP_FIFO_STATUS        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x20)))            //Attributes : RO
#define JS_PMA0_PCS_FELP_FIFO_STATUS        (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x21)))            //Attributes : RO
#define JS_PMA0_PCS_BIT_REV_CTRL            (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0x22)))            //Attributes : RW
#define JS_PMA0_PCS_SOFT_PON_RST            (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0xfe)))            //Attributes : RW
#define JS_PMA0_PCS_PCS_SCRATCH             (*((volatile uint32_t *)(JS_PMA0_PCS_BASE + 4*0xff)))            //Attributes : RW

//------------------------JS1 SUBSYSTEM -------------------------//
//The PMA Lane Config Base Addr
#define JECS_PMA1_LANE0_BASE       JECS_PMA1_CFG + 0x10000*4
#define JECS_PMA1_LANE1_BASE       JECS_PMA1_CFG + 0x10800*4
#define JECS_PMA1_LANE2_BASE       JECS_PMA1_CFG + 0x11000*4
#define JECS_PMA1_LANE3_BASE       JECS_PMA1_CFG + 0x11800*4
#define JECS_PMA1_BROADCAST_BASE   JECS_PMA1_CFG + 0x12000*4
//The PMA COMMON Base Addr
#define JECS_PMA1_COMMON_BASE      JECS_PMA1_CFG + 0x14000*4

//The PMA PCS Addr
#define JECS_PMA1_PCS_BASE         JECS_PMA1_CFG + 0x18000*4


//The PMA Lane Config Register
#define JECS_PMA1_LANE0_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x01)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x02)))            //Attributes : RO
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x03)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x07)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x08)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x09)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x0A)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x0B)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x10)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x11)))            //Attributes : RO
#define JECS_PMA1_LANE0_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x12)))            //Attributes : RO
#define JECS_PMA1_LANE0_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x13)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x14)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x20)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x21)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x23)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x24)))            //Attributes : RO
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x25)))            //Attributes : RO
#define JECS_PMA1_LANE0_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x26)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_RESET                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x30)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x31)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x32)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x40)))            //Attributes : RW
#define JECS_PMA1_LANE0_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x41)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x50)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x51)))            //Attributes : RO
#define JECS_PMA1_LANE0_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x52)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x53)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x55)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x60)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x61)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x62)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x63)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x70)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x71)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x72)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x80)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x81)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x82)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x83)))            //Attributes : RW
#define JECS_PMA1_LANE0_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x90)))            //Attributes : RW
#define JECS_PMA1_LANE0_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x91)))            //Attributes : RW
#define JECS_PMA1_LANE0_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x92)))            //Attributes : RW
#define JECS_PMA1_LANE0_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x93)))            //Attributes : RW
#define JECS_PMA1_LANE0_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x94)))            //Attributes : RW
#define JECS_PMA1_LANE0_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xA0)))            //Attributes : RW
#define JECS_PMA1_LANE0_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xB0)))            //Attributes : RW
#define JECS_PMA1_LANE0_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xB1)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC0)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_DCC_CTRL                             (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC1)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC2)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC3)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC4)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC5)))            //Attributes : RO
#define JECS_PMA1_LANE0_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC6)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC8)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xC9)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xCA)))            //Attributes : RW
#define JECS_PMA1_LANE0_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xCB)))            //Attributes : RW
#define JECS_PMA1_LANE0_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xCC)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD0)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD1)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD2)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD3)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD4)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD5)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD6)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD7)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD8)))            //Attributes : RW
#define JECS_PMA1_LANE0_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xD9)))            //Attributes : RO
#define JECS_PMA1_LANE0_PLL_STATE_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xDA)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_VALID_PHY                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xDF)))            //Attributes : RO
#define JECS_PMA1_LANE0_RX_VALID_MUX                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE0)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE1)))            //Attributes : RW
#define JECS_PMA1_LANE0_SRIO_DEGRADED                           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE2)))            //Attributes : RW
#define JECS_PMA1_LANE0_SRIO_RETRAIN                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE3)))            //Attributes : RW
#define JECS_PMA1_LANE0_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE4)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_INIT_C0                              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE5)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_INIT_CN1                             (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE6)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_INIT_CP1                             (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE7)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE8)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xE9)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xEA)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xEB)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xEC)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xED)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xEE)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xEF)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF0)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF1)))            //Attributes : RW
#define JECS_PMA1_LANE0_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF2)))            //Attributes : RO
#define JECS_PMA1_LANE0_EQ_FSM                                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF3)))            //Attributes : RO
#define JECS_PMA1_LANE0_ETH_RX_LOS                              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF4)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_PRESET_C0                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF5)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF6)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF7)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xF8)))            //Attributes : RW
#define JECS_PMA1_LANE0_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0xff)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x108)))            //Attributes : RW
#define JECS_PMA1_LANE0_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x10D)))            //Attributes : RW
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x118)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x11D)))            //Attributes : RW
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x128)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x12D)))            //Attributes : RW
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x138)))            //Attributes : RW
#define JECS_PMA1_LANE0_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE0_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE0_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE0_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE0_BASE + 4*0x13D)))            //Attributes : RW

#define JECS_PMA1_LANE1_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x01)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x02)))            //Attributes : RO
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x03)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x07)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x08)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x09)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x0A)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x0B)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x10)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x11)))            //Attributes : RO
#define JECS_PMA1_LANE1_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x12)))            //Attributes : RO
#define JECS_PMA1_LANE1_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x13)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x14)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x20)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x21)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x23)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x24)))            //Attributes : RO
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x25)))            //Attributes : RO
#define JECS_PMA1_LANE1_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x26)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_RESET                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x30)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x31)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x32)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x40)))            //Attributes : RW
#define JECS_PMA1_LANE1_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x41)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x50)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x51)))            //Attributes : RO
#define JECS_PMA1_LANE1_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x52)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x53)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x55)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x60)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x61)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x62)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x63)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x70)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x71)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x72)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x80)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x81)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x82)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x83)))            //Attributes : RW
#define JECS_PMA1_LANE1_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x90)))            //Attributes : RW
#define JECS_PMA1_LANE1_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x91)))            //Attributes : RW
#define JECS_PMA1_LANE1_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x92)))            //Attributes : RW
#define JECS_PMA1_LANE1_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x93)))            //Attributes : RW
#define JECS_PMA1_LANE1_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x94)))            //Attributes : RW
#define JECS_PMA1_LANE1_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xA0)))            //Attributes : RW
#define JECS_PMA1_LANE1_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xB0)))            //Attributes : RW
#define JECS_PMA1_LANE1_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xB1)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC0)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_DCC_CTRL                             (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC1)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC2)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC3)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC4)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC5)))            //Attributes : RO
#define JECS_PMA1_LANE1_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC6)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC8)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xC9)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xCA)))            //Attributes : RW
#define JECS_PMA1_LANE1_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xCB)))            //Attributes : RW
#define JECS_PMA1_LANE1_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xCC)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD0)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD1)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD2)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD3)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD4)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD5)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD6)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD7)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD8)))            //Attributes : RW
#define JECS_PMA1_LANE1_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xD9)))            //Attributes : RO
#define JECS_PMA1_LANE1_PLL_STATE_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xDA)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_VALID_PHY                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xDF)))            //Attributes : RO
#define JECS_PMA1_LANE1_RX_VALID_MUX                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE0)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE1)))            //Attributes : RW
#define JECS_PMA1_LANE1_SRIO_DEGRADED                           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE2)))            //Attributes : RW
#define JECS_PMA1_LANE1_SRIO_RETRAIN                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE3)))            //Attributes : RW
#define JECS_PMA1_LANE1_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE4)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_INIT_C0                              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE5)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_INIT_CN1                             (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE6)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_INIT_CP1                             (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE7)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE8)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xE9)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xEA)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xEB)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xEC)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xED)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xEE)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xEF)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF0)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF1)))            //Attributes : RW
#define JECS_PMA1_LANE1_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF2)))            //Attributes : RO
#define JECS_PMA1_LANE1_EQ_FSM                                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF3)))            //Attributes : RO
#define JECS_PMA1_LANE1_ETH_RX_LOS                              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF4)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_PRESET_C0                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF5)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF6)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF7)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xF8)))            //Attributes : RW
#define JECS_PMA1_LANE1_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0xff)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x108)))            //Attributes : RW
#define JECS_PMA1_LANE1_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x10D)))            //Attributes : RW
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x118)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x11D)))            //Attributes : RW
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x128)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x12D)))            //Attributes : RW
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x138)))            //Attributes : RW
#define JECS_PMA1_LANE1_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE1_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE1_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE1_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE1_BASE + 4*0x13D)))            //Attributes : RW

#define JECS_PMA1_LANE2_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x01)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x02)))            //Attributes : RO
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x03)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x07)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x08)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x09)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x0A)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x0B)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x10)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x11)))            //Attributes : RO
#define JECS_PMA1_LANE2_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x12)))            //Attributes : RO
#define JECS_PMA1_LANE2_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x13)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x14)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x20)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x21)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x23)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x24)))            //Attributes : RO
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x25)))            //Attributes : RO
#define JECS_PMA1_LANE2_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x26)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_RESET                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x30)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x31)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x32)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x40)))            //Attributes : RW
#define JECS_PMA1_LANE2_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x41)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x50)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x51)))            //Attributes : RO
#define JECS_PMA1_LANE2_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x52)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x53)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x55)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x60)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x61)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x62)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x63)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x70)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x71)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x72)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x80)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x81)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x82)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x83)))            //Attributes : RW
#define JECS_PMA1_LANE2_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x90)))            //Attributes : RW
#define JECS_PMA1_LANE2_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x91)))            //Attributes : RW
#define JECS_PMA1_LANE2_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x92)))            //Attributes : RW
#define JECS_PMA1_LANE2_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x93)))            //Attributes : RW
#define JECS_PMA1_LANE2_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x94)))            //Attributes : RW
#define JECS_PMA1_LANE2_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xA0)))            //Attributes : RW
#define JECS_PMA1_LANE2_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xB0)))            //Attributes : RW
#define JECS_PMA1_LANE2_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xB1)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC0)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_DCC_CTRL                             (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC1)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC2)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC3)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC4)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC5)))            //Attributes : RO
#define JECS_PMA1_LANE2_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC6)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC8)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xC9)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xCA)))            //Attributes : RW
#define JECS_PMA1_LANE2_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xCB)))            //Attributes : RW
#define JECS_PMA1_LANE2_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xCC)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD0)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD1)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD2)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD3)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD4)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD5)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD6)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD7)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD8)))            //Attributes : RW
#define JECS_PMA1_LANE2_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xD9)))            //Attributes : RO
#define JECS_PMA1_LANE2_PLL_STATE_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xDA)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_VALID_PHY                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xDF)))            //Attributes : RO
#define JECS_PMA1_LANE2_RX_VALID_MUX                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE0)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE1)))            //Attributes : RW
#define JECS_PMA1_LANE2_SRIO_DEGRADED                           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE2)))            //Attributes : RW
#define JECS_PMA1_LANE2_SRIO_RETRAIN                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE3)))            //Attributes : RW
#define JECS_PMA1_LANE2_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE4)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_INIT_C0                              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE5)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_INIT_CN1                             (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE6)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_INIT_CP1                             (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE7)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE8)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xE9)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xEA)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xEB)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xEC)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xED)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xEE)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xEF)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF0)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF1)))            //Attributes : RW
#define JECS_PMA1_LANE2_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF2)))            //Attributes : RO
#define JECS_PMA1_LANE2_EQ_FSM                                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF3)))            //Attributes : RO
#define JECS_PMA1_LANE2_ETH_RX_LOS                              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF4)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_PRESET_C0                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF5)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF6)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF7)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xF8)))            //Attributes : RW
#define JECS_PMA1_LANE2_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0xff)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x108)))            //Attributes : RW
#define JECS_PMA1_LANE2_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x10D)))            //Attributes : RW
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x118)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x11D)))            //Attributes : RW
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x128)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x12D)))            //Attributes : RW
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x138)))            //Attributes : RW
#define JECS_PMA1_LANE2_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE2_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE2_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE2_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE2_BASE + 4*0x13D)))            //Attributes : RW

#define JECS_PMA1_LANE3_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x01)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x02)))            //Attributes : RO
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x03)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x07)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x08)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x09)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x0A)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x0B)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x10)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x11)))            //Attributes : RO
#define JECS_PMA1_LANE3_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x12)))            //Attributes : RO
#define JECS_PMA1_LANE3_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x13)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x14)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x20)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x21)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x23)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x24)))            //Attributes : RO
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x25)))            //Attributes : RO
#define JECS_PMA1_LANE3_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x26)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_RESET                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x30)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x31)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x32)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x40)))            //Attributes : RW
#define JECS_PMA1_LANE3_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x41)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x50)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x51)))            //Attributes : RO
#define JECS_PMA1_LANE3_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x52)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x53)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x55)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x60)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x61)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x62)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x63)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x70)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x71)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x72)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x80)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x81)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x82)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x83)))            //Attributes : RW
#define JECS_PMA1_LANE3_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x90)))            //Attributes : RW
#define JECS_PMA1_LANE3_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x91)))            //Attributes : RW
#define JECS_PMA1_LANE3_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x92)))            //Attributes : RW
#define JECS_PMA1_LANE3_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x93)))            //Attributes : RW
#define JECS_PMA1_LANE3_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x94)))            //Attributes : RW
#define JECS_PMA1_LANE3_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xA0)))            //Attributes : RW
#define JECS_PMA1_LANE3_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xB0)))            //Attributes : RW
#define JECS_PMA1_LANE3_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xB1)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC0)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_DCC_CTRL                             (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC1)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC2)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC3)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC4)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC5)))            //Attributes : RO
#define JECS_PMA1_LANE3_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC6)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC8)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xC9)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xCA)))            //Attributes : RW
#define JECS_PMA1_LANE3_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xCB)))            //Attributes : RW
#define JECS_PMA1_LANE3_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xCC)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD0)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD1)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD2)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD3)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD4)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD5)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD6)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD7)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD8)))            //Attributes : RW
#define JECS_PMA1_LANE3_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xD9)))            //Attributes : RO
#define JECS_PMA1_LANE3_PLL_STATE_MUX                           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xDA)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_VALID_PHY                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xDF)))            //Attributes : RO
#define JECS_PMA1_LANE3_RX_VALID_MUX                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE0)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE1)))            //Attributes : RW
#define JECS_PMA1_LANE3_SRIO_DEGRADED                           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE2)))            //Attributes : RW
#define JECS_PMA1_LANE3_SRIO_RETRAIN                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE3)))            //Attributes : RW
#define JECS_PMA1_LANE3_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE4)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_INIT_C0                              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE5)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_INIT_CN1                             (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE6)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_INIT_CP1                             (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE7)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE8)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xE9)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xEA)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xEB)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xEC)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xED)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xEE)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xEF)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF0)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF1)))            //Attributes : RW
#define JECS_PMA1_LANE3_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF2)))            //Attributes : RO
#define JECS_PMA1_LANE3_EQ_FSM                                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF3)))            //Attributes : RO
#define JECS_PMA1_LANE3_ETH_RX_LOS                              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF4)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_PRESET_C0                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF5)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF6)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF7)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xF8)))            //Attributes : RW
#define JECS_PMA1_LANE3_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0xff)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x108)))            //Attributes : RW
#define JECS_PMA1_LANE3_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x10D)))            //Attributes : RW
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x118)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x11D)))            //Attributes : RW
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x128)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x12D)))            //Attributes : RW
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x138)))            //Attributes : RW
#define JECS_PMA1_LANE3_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JECS_PMA1_LANE3_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JECS_PMA1_LANE3_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_LANE3_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JECS_PMA1_LANE3_BASE + 4*0x13D)))            //Attributes : RW

#define JECS_PMA1_BROADCAST_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x01)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x02)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x03)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x07)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x08)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x09)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x0A)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x0B)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x10)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x11)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x12)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x13)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x14)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x20)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x21)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x23)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x24)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x25)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x26)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_RESET                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x30)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_CONTROL                        (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x31)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x32)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x40)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x41)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_REQ                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x50)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x51)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x52)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x53)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x55)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x60)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x61)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x62)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x63)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x70)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x71)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x72)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x80)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x81)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x82)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x83)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x90)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x91)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x92)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x93)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x94)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xA0)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_ETH_CLK_CTRL                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xB0)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xB1)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC0)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_DCC_CTRL                             (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC1)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_EQ_CTRL1                             (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC2)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_EQ_CTRL2                             (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC3)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC4)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC5)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC6)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC8)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xC9)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xCA)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xCB)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xCC)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD0)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD1)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD2)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD3)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD4)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_REQ_MUX                           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD5)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD6)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD7)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD8)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TRANS_PLL_STATE                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xD9)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_PLL_STATE_MUX                           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xDA)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_VALID_PHY                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xDF)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_RX_VALID_MUX                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE0)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE1)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_SRIO_DEGRADED                           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE2)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_SRIO_RETRAIN                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE3)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE4)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_INIT_C0                              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE5)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_INIT_CN1                             (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE6)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_INIT_CP1                             (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE7)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE8)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xE9)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xEA)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xEB)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xEC)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xED)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xEE)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xEF)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF0)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF1)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF2)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_EQ_FSM                                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF3)))            //Attributes : RO
#define JECS_PMA1_BROADCAST_ETH_RX_LOS                              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF4)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_PRESET_C0                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF5)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_PRESET_CN1                           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF6)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_PRESET_CP1                           (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF7)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_SUCC_MASK                            (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xF8)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0xff)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x101)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x102)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x103)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x104)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x105)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x106)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x108)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x10D)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x111)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x112)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x113)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x114)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x115)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x116)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x118)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x11D)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x121)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x122)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x123)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x124)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x125)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x126)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x128)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x12D)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x131)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x132)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x133)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x134)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x135)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x136)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x138)))            //Attributes : RW
#define JECS_PMA1_BROADCAST_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define JECS_PMA1_BROADCAST_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define JECS_PMA1_BROADCAST_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define JECS_PMA1_BROADCAST_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(JECS_PMA1_BROADCAST_BASE + 4*0x13D)))            //Attributes : RW

//The PMA COMMON Register
#define JECS_PMA1_MPLLA_PARAM1                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_MPLLA_PARAM2                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x01)))            //Attributes : RW
#define JECS_PMA1_MPLLA_PARAM3                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x02)))            //Attributes : RW
#define JECS_PMA1_MPLLA_PARAM4                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x03)))            //Attributes : RW
#define JECS_PMA1_MPLLA_PARAM5                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_MPLLA_PARAM6                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_MPLLA_FORCE_EN              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_MPLLA_FORCE_ACK             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x07)))            //Attributes : RO
#define JECS_PMA1_MPLLB_PARAM1                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x08)))            //Attributes : RW
#define JECS_PMA1_MPLLB_PARAM2                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x09)))            //Attributes : RW
#define JECS_PMA1_MPLLB_PARAM3                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x0A)))            //Attributes : RW
#define JECS_PMA1_MPLLB_PARAM4                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x0B)))            //Attributes : RW
#define JECS_PMA1_MPLLB_PARAM5                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x0C)))            //Attributes : RW
#define JECS_PMA1_MPLLB_PARAM6                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x0D)))            //Attributes : RW
#define JECS_PMA1_MPLLB_FORCE_EN              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x0E)))            //Attributes : RW
#define JECS_PMA1_MPLLB_FORCE_ACK             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x0F)))            //Attributes : RO
#define JECS_PMA1_SUP_MISC                    (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x16)))            //Attributes : RW
#define JECS_PMA1_MPLLA_FRAC_CTRL1            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x17)))            //Attributes : RW
#define JECS_PMA1_MPLLA_FRAC_CTRL2            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x18)))            //Attributes : RW
#define JECS_PMA1_MPLLA_FRAC_CTRL3            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x19)))            //Attributes : RW
#define JECS_PMA1_MPLLA_FRAC_CTRL4            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x1A)))            //Attributes : RW
#define JECS_PMA1_MPLLA_SSC_CTRL1             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x1B)))            //Attributes : RW
#define JECS_PMA1_MPLLA_SSC_CTRL2             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x1C)))            //Attributes : RW_EXT_L
#define JECS_PMA1_MPLLA_SSC_CTRL3             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x1D)))            //Attributes : RW_EXT_H
#define JECS_PMA1_MPLLA_SSC_CTRL4             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x1E)))            //Attributes : RW
#define JECS_PMA1_MPLLA_SSC_CTRL5             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x1F)))            //Attributes : RW_EXT_L
#define JECS_PMA1_MPLLA_SSC_CTRL6             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x20)))            //Attributes : RW_EXT_H
#define JECS_PMA1_MPLLB_FRAC_CTRL1            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x21)))            //Attributes : RW
#define JECS_PMA1_MPLLB_FRAC_CTRL2            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_MPLLB_FRAC_CTRL3            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x23)))            //Attributes : RW
#define JECS_PMA1_MPLLB_FRAC_CTRL4            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x24)))            //Attributes : RW
#define JECS_PMA1_MPLLB_SSC_CTRL1             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x25)))            //Attributes : RW
#define JECS_PMA1_MPLLB_SSC_CTRL2             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x26)))            //Attributes : RW_EXT_L
#define JECS_PMA1_MPLLB_SSC_CTRL3             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x27)))            //Attributes : RW_EXT_H
#define JECS_PMA1_MPLLB_SSC_CTRL4             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x28)))            //Attributes : RW
#define JECS_PMA1_MPLLB_SSC_CTRL5             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x29)))            //Attributes : RW_EXT_L
#define JECS_PMA1_MPLLB_SSC_CTRL6             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x2A)))            //Attributes : RW_EXT_H
#define JECS_PMA1_MPLLA_RECAL_CTRL            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x2B)))            //Attributes : RW
#define JECS_PMA1_MPLLB_RECAL_CTRL            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x2C)))            //Attributes : RW
#define JECS_PMA1_MPLL_CTRL_MUX               (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x2D)))            //Attributes : RW
#define JECS_PMA1_POWER_SUPPLY_SEL            (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x30)))            //Attributes : RW
#define JECS_PMA1_PHY_RESET                   (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x31)))            //Attributes : RW
#define JECS_PMA1_REF_CLK_CTRL                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x40)))            //Attributes : RW
#define JECS_PMA1_REFA_CLK_CTRL1              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x41)))            //Attributes : RW
#define JECS_PMA1_REFA_CLK_CTRL2              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x42)))            //Attributes : RW
#define JECS_PMA1_REFA_CLK_STATUS             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x43)))            //Attributes : RO
#define JECS_PMA1_REFB_CLK_CTRL1              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x44)))            //Attributes : RW
#define JECS_PMA1_REFB_CLK_CTRL2              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x45)))            //Attributes : RW
#define JECS_PMA1_REFB_CLK_STATUS             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x46)))            //Attributes : RO
#define JECS_PMA1_REF_CLK_MUX                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x47)))            //Attributes : RW
#define JECS_PMA1_RES_ACK_IN                  (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x50)))            //Attributes : RW
#define JECS_PMA1_RES_ACK_OUT                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x51)))            //Attributes : RO
#define JECS_PMA1_RES_REQ_IN                  (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x52)))            //Attributes : RW
#define JECS_PMA1_RES_REQ_OUT                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x53)))            //Attributes : RO
#define JECS_PMA1_RTUNE_REQ                   (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x54)))            //Attributes : RW
#define JECS_PMA1_RTUNE_ACK                   (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x55)))            //Attributes : RO
#define JECS_PMA1_RTUNE_CTRL1                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x56)))            //Attributes : RW
#define JECS_PMA1_RTUNE_CTRL2                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x57)))            //Attributes : RW
#define JECS_PMA1_RTUNE_CTRL3                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x58)))            //Attributes : RW
#define JECS_PMA1_RX_BIAS_CURRENT_CTRL        (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x59)))            //Attributes : RW
#define JECS_PMA1_CR_PARA_SEL                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x90)))            //Attributes : RW
#define JECS_PMA1_POWER_GATING_SIGNAL1        (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x60)))            //Attributes : RW
#define JECS_PMA1_POWER_GATING_SIGNAL2        (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x61)))            //Attributes : RO
#define JECS_PMA1_POWER_GATING_SIGNAL3        (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x62)))            //Attributes : RW
#define JECS_PMA1_SRAM_CTRL                   (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x68)))            //Attributes : RW
#define JECS_PMA1_SRAM_STATUS                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x69)))            //Attributes : RO
#define JECS_PMA1_SRIO_RST_REQ                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x6A)))            //Attributes : RO
#define JECS_PMA1_SRIO_GEN3_EN                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x6C)))            //Attributes : RW
#define JECS_PMA1_SRIO_RATE_OUT               (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x6D)))            //Attributes : RW
#define JECS_PMA1_CPRI_RST_REQ                (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x70)))            //Attributes : RW
#define JECS_PMA1_CPRI_RX_LOS                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x71)))            //Attributes : RW
#define JECS_PMA1_CPRI_SIGNAL_OK              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x72)))            //Attributes : RW
#define JECS_PMA1_CPRI_ENERGY_DET             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x73)))            //Attributes : RW
#define JECS_PMA1_CPRI_SIGDET                 (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x74)))            //Attributes : RW
#define JECS_PMA1_CPRI_PCS_STATUS             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x75)))            //Attributes : RO
#define JECS_PMA1_CPRI_PCS_STATUS_CTRL        (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x76)))            //Attributes : RW
#define JECS_PMA1_ETH_ENERGY_DET              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x80)))            //Attributes : RW
#define JECS_PMA1_ETH_SPEED_CTRL              (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0x81)))            //Attributes : RO
#define JECS_PMA1_TX_CLK_SEL                  (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0xF0)))            //Attributes : RW
#define JECS_PMA1_RPCS_TX_CLK_SEL             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0xF1)))            //Attributes : RW
#define JECS_PMA1_RPCS_RX_CLK_SEL             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0xF2)))            //Attributes : RW
#define JECS_PMA1_PMA_COM_SCRATCH             (*((volatile uint32_t *)(JECS_PMA1_COMMON_BASE + 4*0xff)))            //Attributes : RW

//The PMA PCS Register
#define JECS_PMA1_PCS_SOFT_RESET              (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x00)))            //Attributes : RW
#define JECS_PMA1_PCS_LOOPBACK_CTRL           (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x04)))            //Attributes : RW
#define JECS_PMA1_PCS_PRBS_UDP_SEND           (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x05)))            //Attributes : RW
#define JECS_PMA1_PCS_PRBS_SEND_ERRINS        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x06)))            //Attributes : RW
#define JECS_PMA1_PCS_TXUDP_0                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x07)))            //Attributes : RW_EXT_L
#define JECS_PMA1_PCS_TXUDP_1                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x08)))            //Attributes : RW_EXT
#define JECS_PMA1_PCS_TXUDP_2                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x09)))            //Attributes : RW_EXT
#define JECS_PMA1_PCS_TXUDP_3                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x0A)))            //Attributes : RW_EXT
#define JECS_PMA1_PCS_TXUDP_4                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x0B)))            //Attributes : RW_EXT_H
#define JECS_PMA1_PCS_PRBS_UDP_CHK            (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x10)))            //Attributes : RW
#define JECS_PMA1_PCS_RXUDP_0                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x11)))            //Attributes : RW_EXT_L
#define JECS_PMA1_PCS_RXUDP_1                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x12)))            //Attributes : RW_EXT
#define JECS_PMA1_PCS_RXUDP_2                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x13)))            //Attributes : RW_EXT
#define JECS_PMA1_PCS_RXUDP_3                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x14)))            //Attributes : RW_EXT
#define JECS_PMA1_PCS_RXUDP_4                 (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x15)))            //Attributes : RW_EXT_H
#define JECS_PMA1_PCS_RXPRBS_ERRCNT_L0        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x16)))            //Attributes : RO
#define JECS_PMA1_PCS_RXPRBS_ERRCNT_L1        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x17)))            //Attributes : RO
#define JECS_PMA1_PCS_RXPRBS_ERRCNT_L2        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x18)))            //Attributes : RO
#define JECS_PMA1_PCS_RXPRBS_ERRCNT_L3        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x19)))            //Attributes : RO
#define JECS_PMA1_PCS_NELP_FIFO_STATUS        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x20)))            //Attributes : RO
#define JECS_PMA1_PCS_FELP_FIFO_STATUS        (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x21)))            //Attributes : RO
#define JECS_PMA1_PCS_BIT_REV_CTRL            (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0x22)))            //Attributes : RW
#define JECS_PMA1_PCS_SOFT_PON_RST            (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0xfe)))            //Attributes : RW
#define JECS_PMA1_PCS_PCS_SCRATCH             (*((volatile uint32_t *)(JECS_PMA1_PCS_BASE + 4*0xff)))            //Attributes : RW

//------------------------PET SUBSYSTEM -------------------------//
//The PMA Lane Config Base Addr
#define PET_PMA3_LANE0_BASE       PET_PMA3_CFG + 0x10000*4
#define PET_PMA3_LANE1_BASE       PET_PMA3_CFG + 0x10800*4
#define PET_PMA3_LANE2_BASE       PET_PMA3_CFG + 0x11000*4
#define PET_PMA3_LANE3_BASE       PET_PMA3_CFG + 0x11800*4
#define PET_PMA3_BROADCAST_BASE   PET_PMA3_CFG + 0x12000*4
//The PMA COMMON Base Addr
#define PET_PMA3_COMMON_BASE      PET_PMA3_CFG + 0x14000*4

//The PMA PCS Addr
#define PET_PMA3_PCS_BASE         PET_PMA3_CFG + 0x18000*4


//The PMA Lane Config Register
#define PET_PMA3_LANE0_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x01)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x02)))            //Attributes : RO
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x03)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x07)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x08)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x09)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x0A)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x0B)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x10)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x11)))            //Attributes : RO
#define PET_PMA3_LANE0_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x12)))            //Attributes : RO
#define PET_PMA3_LANE0_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x13)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x14)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x20)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x21)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x23)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x24)))            //Attributes : RO
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x25)))            //Attributes : RO
#define PET_PMA3_LANE0_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x26)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_RESET                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x30)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_CONTROL                        (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x31)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x32)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x40)))            //Attributes : RW
#define PET_PMA3_LANE0_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x41)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_REQ                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x50)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x51)))            //Attributes : RO
#define PET_PMA3_LANE0_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x52)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x53)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x55)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x60)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x61)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x62)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x63)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x70)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x71)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x72)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x80)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x81)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x82)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x83)))            //Attributes : RW
#define PET_PMA3_LANE0_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x90)))            //Attributes : RW
#define PET_PMA3_LANE0_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x91)))            //Attributes : RW
#define PET_PMA3_LANE0_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x92)))            //Attributes : RW
#define PET_PMA3_LANE0_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x93)))            //Attributes : RW
#define PET_PMA3_LANE0_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x94)))            //Attributes : RW
#define PET_PMA3_LANE0_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xA0)))            //Attributes : RW
#define PET_PMA3_LANE0_ETH_CLK_CTRL                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xB0)))            //Attributes : RW
#define PET_PMA3_LANE0_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xB1)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC0)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_DCC_CTRL                             (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC1)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_EQ_CTRL1                             (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC2)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_EQ_CTRL2                             (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC3)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC4)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC5)))            //Attributes : RO
#define PET_PMA3_LANE0_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC6)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC8)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xC9)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xCA)))            //Attributes : RW
#define PET_PMA3_LANE0_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xCB)))            //Attributes : RW
#define PET_PMA3_LANE0_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xCC)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD0)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD1)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD2)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD3)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD4)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_REQ_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD5)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD6)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD7)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD8)))            //Attributes : RW
#define PET_PMA3_LANE0_TRANS_PLL_STATE                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xD9)))            //Attributes : RO
#define PET_PMA3_LANE0_PLL_STATE_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xDA)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_VALID_PHY                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xDF)))            //Attributes : RO
#define PET_PMA3_LANE0_RX_VALID_MUX                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE0)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE1)))            //Attributes : RW
#define PET_PMA3_LANE0_SRIO_DEGRADED                           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE2)))            //Attributes : RW
#define PET_PMA3_LANE0_SRIO_RETRAIN                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE3)))            //Attributes : RW
#define PET_PMA3_LANE0_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE4)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_INIT_C0                              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE5)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_INIT_CN1                             (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE6)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_INIT_CP1                             (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE7)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE8)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xE9)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xEA)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xEB)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xEC)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xED)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xEE)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xEF)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF0)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF1)))            //Attributes : RW
#define PET_PMA3_LANE0_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF2)))            //Attributes : RO
#define PET_PMA3_LANE0_EQ_FSM                                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF3)))            //Attributes : RO
#define PET_PMA3_LANE0_ETH_RX_LOS                              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF4)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_PRESET_C0                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF5)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_PRESET_CN1                           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF6)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_PRESET_CP1                           (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF7)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_SUCC_MASK                            (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xF8)))            //Attributes : RW
#define PET_PMA3_LANE0_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0xff)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x101)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x102)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x103)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x104)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x105)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x106)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x108)))            //Attributes : RW
#define PET_PMA3_LANE0_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x10D)))            //Attributes : RW
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x111)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x112)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x113)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x114)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x115)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x116)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x118)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x11D)))            //Attributes : RW
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x121)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x122)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x123)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x124)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x125)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x126)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x128)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x12D)))            //Attributes : RW
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x131)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x132)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x133)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x134)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x135)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x136)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x138)))            //Attributes : RW
#define PET_PMA3_LANE0_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE0_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE0_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE0_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE0_BASE + 4*0x13D)))            //Attributes : RW

#define PET_PMA3_LANE1_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x01)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x02)))            //Attributes : RO
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x03)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x07)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x08)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x09)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x0A)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x0B)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x10)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x11)))            //Attributes : RO
#define PET_PMA3_LANE1_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x12)))            //Attributes : RO
#define PET_PMA3_LANE1_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x13)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x14)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x20)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x21)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x23)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x24)))            //Attributes : RO
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x25)))            //Attributes : RO
#define PET_PMA3_LANE1_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x26)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_RESET                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x30)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_CONTROL                        (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x31)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x32)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x40)))            //Attributes : RW
#define PET_PMA3_LANE1_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x41)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_REQ                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x50)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x51)))            //Attributes : RO
#define PET_PMA3_LANE1_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x52)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x53)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x55)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x60)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x61)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x62)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x63)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x70)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x71)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x72)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x80)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x81)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x82)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x83)))            //Attributes : RW
#define PET_PMA3_LANE1_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x90)))            //Attributes : RW
#define PET_PMA3_LANE1_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x91)))            //Attributes : RW
#define PET_PMA3_LANE1_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x92)))            //Attributes : RW
#define PET_PMA3_LANE1_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x93)))            //Attributes : RW
#define PET_PMA3_LANE1_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x94)))            //Attributes : RW
#define PET_PMA3_LANE1_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xA0)))            //Attributes : RW
#define PET_PMA3_LANE1_ETH_CLK_CTRL                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xB0)))            //Attributes : RW
#define PET_PMA3_LANE1_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xB1)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC0)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_DCC_CTRL                             (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC1)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_EQ_CTRL1                             (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC2)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_EQ_CTRL2                             (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC3)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC4)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC5)))            //Attributes : RO
#define PET_PMA3_LANE1_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC6)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC8)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xC9)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xCA)))            //Attributes : RW
#define PET_PMA3_LANE1_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xCB)))            //Attributes : RW
#define PET_PMA3_LANE1_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xCC)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD0)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD1)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD2)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD3)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD4)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_REQ_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD5)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD6)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD7)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD8)))            //Attributes : RW
#define PET_PMA3_LANE1_TRANS_PLL_STATE                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xD9)))            //Attributes : RO
#define PET_PMA3_LANE1_PLL_STATE_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xDA)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_VALID_PHY                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xDF)))            //Attributes : RO
#define PET_PMA3_LANE1_RX_VALID_MUX                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE0)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE1)))            //Attributes : RW
#define PET_PMA3_LANE1_SRIO_DEGRADED                           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE2)))            //Attributes : RW
#define PET_PMA3_LANE1_SRIO_RETRAIN                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE3)))            //Attributes : RW
#define PET_PMA3_LANE1_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE4)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_INIT_C0                              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE5)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_INIT_CN1                             (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE6)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_INIT_CP1                             (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE7)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE8)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xE9)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xEA)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xEB)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xEC)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xED)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xEE)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xEF)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF0)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF1)))            //Attributes : RW
#define PET_PMA3_LANE1_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF2)))            //Attributes : RO
#define PET_PMA3_LANE1_EQ_FSM                                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF3)))            //Attributes : RO
#define PET_PMA3_LANE1_ETH_RX_LOS                              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF4)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_PRESET_C0                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF5)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_PRESET_CN1                           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF6)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_PRESET_CP1                           (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF7)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_SUCC_MASK                            (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xF8)))            //Attributes : RW
#define PET_PMA3_LANE1_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0xff)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x101)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x102)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x103)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x104)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x105)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x106)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x108)))            //Attributes : RW
#define PET_PMA3_LANE1_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x10D)))            //Attributes : RW
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x111)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x112)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x113)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x114)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x115)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x116)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x118)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x11D)))            //Attributes : RW
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x121)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x122)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x123)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x124)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x125)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x126)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x128)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x12D)))            //Attributes : RW
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x131)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x132)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x133)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x134)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x135)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x136)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x138)))            //Attributes : RW
#define PET_PMA3_LANE1_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE1_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE1_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE1_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE1_BASE + 4*0x13D)))            //Attributes : RW

#define PET_PMA3_LANE2_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x01)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x02)))            //Attributes : RO
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x03)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x07)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x08)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x09)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x0A)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x0B)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x10)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x11)))            //Attributes : RO
#define PET_PMA3_LANE2_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x12)))            //Attributes : RO
#define PET_PMA3_LANE2_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x13)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x14)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x20)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x21)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x23)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x24)))            //Attributes : RO
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x25)))            //Attributes : RO
#define PET_PMA3_LANE2_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x26)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_RESET                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x30)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_CONTROL                        (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x31)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x32)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x40)))            //Attributes : RW
#define PET_PMA3_LANE2_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x41)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_REQ                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x50)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x51)))            //Attributes : RO
#define PET_PMA3_LANE2_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x52)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x53)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x55)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x60)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x61)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x62)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x63)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x70)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x71)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x72)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x80)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x81)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x82)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x83)))            //Attributes : RW
#define PET_PMA3_LANE2_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x90)))            //Attributes : RW
#define PET_PMA3_LANE2_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x91)))            //Attributes : RW
#define PET_PMA3_LANE2_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x92)))            //Attributes : RW
#define PET_PMA3_LANE2_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x93)))            //Attributes : RW
#define PET_PMA3_LANE2_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x94)))            //Attributes : RW
#define PET_PMA3_LANE2_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xA0)))            //Attributes : RW
#define PET_PMA3_LANE2_ETH_CLK_CTRL                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xB0)))            //Attributes : RW
#define PET_PMA3_LANE2_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xB1)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC0)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_DCC_CTRL                             (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC1)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_EQ_CTRL1                             (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC2)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_EQ_CTRL2                             (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC3)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC4)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC5)))            //Attributes : RO
#define PET_PMA3_LANE2_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC6)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC8)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xC9)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xCA)))            //Attributes : RW
#define PET_PMA3_LANE2_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xCB)))            //Attributes : RW
#define PET_PMA3_LANE2_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xCC)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD0)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD1)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD2)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD3)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD4)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_REQ_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD5)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD6)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD7)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD8)))            //Attributes : RW
#define PET_PMA3_LANE2_TRANS_PLL_STATE                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xD9)))            //Attributes : RO
#define PET_PMA3_LANE2_PLL_STATE_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xDA)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_VALID_PHY                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xDF)))            //Attributes : RO
#define PET_PMA3_LANE2_RX_VALID_MUX                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE0)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE1)))            //Attributes : RW
#define PET_PMA3_LANE2_SRIO_DEGRADED                           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE2)))            //Attributes : RW
#define PET_PMA3_LANE2_SRIO_RETRAIN                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE3)))            //Attributes : RW
#define PET_PMA3_LANE2_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE4)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_INIT_C0                              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE5)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_INIT_CN1                             (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE6)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_INIT_CP1                             (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE7)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE8)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xE9)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xEA)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xEB)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xEC)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xED)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xEE)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xEF)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF0)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF1)))            //Attributes : RW
#define PET_PMA3_LANE2_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF2)))            //Attributes : RO
#define PET_PMA3_LANE2_EQ_FSM                                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF3)))            //Attributes : RO
#define PET_PMA3_LANE2_ETH_RX_LOS                              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF4)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_PRESET_C0                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF5)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_PRESET_CN1                           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF6)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_PRESET_CP1                           (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF7)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_SUCC_MASK                            (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xF8)))            //Attributes : RW
#define PET_PMA3_LANE2_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0xff)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x101)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x102)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x103)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x104)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x105)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x106)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x108)))            //Attributes : RW
#define PET_PMA3_LANE2_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x10D)))            //Attributes : RW
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x111)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x112)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x113)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x114)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x115)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x116)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x118)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x11D)))            //Attributes : RW
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x121)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x122)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x123)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x124)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x125)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x126)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x128)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x12D)))            //Attributes : RW
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x131)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x132)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x133)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x134)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x135)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x136)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x138)))            //Attributes : RW
#define PET_PMA3_LANE2_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE2_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE2_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE2_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE2_BASE + 4*0x13D)))            //Attributes : RW

#define PET_PMA3_LANE3_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x01)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x02)))            //Attributes : RO
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x03)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x07)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x08)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x09)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x0A)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x0B)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x10)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x11)))            //Attributes : RO
#define PET_PMA3_LANE3_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x12)))            //Attributes : RO
#define PET_PMA3_LANE3_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x13)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x14)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x20)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x21)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x23)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x24)))            //Attributes : RO
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x25)))            //Attributes : RO
#define PET_PMA3_LANE3_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x26)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_RESET                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x30)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_CONTROL                        (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x31)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x32)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x40)))            //Attributes : RW
#define PET_PMA3_LANE3_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x41)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_REQ                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x50)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x51)))            //Attributes : RO
#define PET_PMA3_LANE3_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x52)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x53)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x55)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x60)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x61)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x62)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x63)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x70)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x71)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x72)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x80)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x81)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x82)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x83)))            //Attributes : RW
#define PET_PMA3_LANE3_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x90)))            //Attributes : RW
#define PET_PMA3_LANE3_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x91)))            //Attributes : RW
#define PET_PMA3_LANE3_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x92)))            //Attributes : RW
#define PET_PMA3_LANE3_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x93)))            //Attributes : RW
#define PET_PMA3_LANE3_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x94)))            //Attributes : RW
#define PET_PMA3_LANE3_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xA0)))            //Attributes : RW
#define PET_PMA3_LANE3_ETH_CLK_CTRL                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xB0)))            //Attributes : RW
#define PET_PMA3_LANE3_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xB1)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC0)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_DCC_CTRL                             (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC1)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_EQ_CTRL1                             (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC2)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_EQ_CTRL2                             (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC3)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC4)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC5)))            //Attributes : RO
#define PET_PMA3_LANE3_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC6)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC8)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xC9)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xCA)))            //Attributes : RW
#define PET_PMA3_LANE3_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xCB)))            //Attributes : RW
#define PET_PMA3_LANE3_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xCC)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD0)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD1)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD2)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD3)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD4)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_REQ_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD5)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD6)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD7)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD8)))            //Attributes : RW
#define PET_PMA3_LANE3_TRANS_PLL_STATE                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xD9)))            //Attributes : RO
#define PET_PMA3_LANE3_PLL_STATE_MUX                           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xDA)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_VALID_PHY                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xDF)))            //Attributes : RO
#define PET_PMA3_LANE3_RX_VALID_MUX                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE0)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE1)))            //Attributes : RW
#define PET_PMA3_LANE3_SRIO_DEGRADED                           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE2)))            //Attributes : RW
#define PET_PMA3_LANE3_SRIO_RETRAIN                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE3)))            //Attributes : RW
#define PET_PMA3_LANE3_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE4)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_INIT_C0                              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE5)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_INIT_CN1                             (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE6)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_INIT_CP1                             (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE7)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE8)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xE9)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xEA)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xEB)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xEC)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xED)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xEE)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xEF)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF0)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF1)))            //Attributes : RW
#define PET_PMA3_LANE3_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF2)))            //Attributes : RO
#define PET_PMA3_LANE3_EQ_FSM                                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF3)))            //Attributes : RO
#define PET_PMA3_LANE3_ETH_RX_LOS                              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF4)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_PRESET_C0                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF5)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_PRESET_CN1                           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF6)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_PRESET_CP1                           (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF7)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_SUCC_MASK                            (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xF8)))            //Attributes : RW
#define PET_PMA3_LANE3_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0xff)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x101)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x102)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x103)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x104)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x105)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x106)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x108)))            //Attributes : RW
#define PET_PMA3_LANE3_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x10D)))            //Attributes : RW
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x111)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x112)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x113)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x114)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x115)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x116)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x118)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x11D)))            //Attributes : RW
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x121)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x122)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x123)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x124)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x125)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x126)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x128)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x12D)))            //Attributes : RW
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x131)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x132)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x133)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x134)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x135)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x136)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x138)))            //Attributes : RW
#define PET_PMA3_LANE3_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define PET_PMA3_LANE3_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define PET_PMA3_LANE3_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define PET_PMA3_LANE3_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(PET_PMA3_LANE3_BASE + 4*0x13D)))            //Attributes : RW

#define PET_PMA3_BROADCAST_PMA_LOOPBACK_CTRL                       (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x01)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_ACK                        (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x02)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM2                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x03)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM3                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM4                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM5                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM6                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x07)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM7                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x08)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM8                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x09)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_PARAM9                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x0A)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_REQ_MUX_CTRL                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x0B)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_ADAPT_REQ                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x10)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_ADAPT_REQ_ACK                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x11)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RECEIVER_ADAPT_DIR                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x12)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RECEIVER_ADAPT_SETTING                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x13)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_ADAPT_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x14)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_EN                    (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x20)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_SETTING1              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x21)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_SETTING2              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_SETTING3              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x23)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_STATUS1               (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x24)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_STATUS2               (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x25)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RECEIVER_DATAPATH_MUX_CTRL              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x26)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_RESET                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x30)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_CONTROL                        (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x31)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_CONTROL_MUX_CTRL               (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x32)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_RECAL_CTRL                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x40)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RECEIVER_RECAL_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x41)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_REQ                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x50)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_REQ_ACK                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x51)))            //Attributes : RO
#define PET_PMA3_BROADCAST_TRANSMITTER_REQ_PARAM1                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x52)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_REQ_PARAM2                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x53)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_REQ_MUX_CTRL                (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x55)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_DATAPATH_EN                 (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x60)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_DATAPATH_CLKRDY             (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x61)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_DATAPATH_SETTING            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x62)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_DATAPATH_MUX_CTRL           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x63)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_CONTROL1                    (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x70)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_CONTROL2                    (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x71)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_CONTROL_MUX_CTRL            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x72)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_EQ1                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x80)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_EQ2                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x81)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_EQ3                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x82)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANSMITTER_EQ_MUX_CTRL                 (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x83)))            //Attributes : RW
#define PET_PMA3_BROADCAST_CONTEXT_RESTORE_CTRL1                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x90)))            //Attributes : RW
#define PET_PMA3_BROADCAST_CONTEXT_RESTORE_CTRL2                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x91)))            //Attributes : RW
#define PET_PMA3_BROADCAST_CONTEXT_RESTORE_CTRL3                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x92)))            //Attributes : RW
#define PET_PMA3_BROADCAST_CONTEXT_RESTORE_CTRL4                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x93)))            //Attributes : RW
#define PET_PMA3_BROADCAST_CONTEXT_RESTORE_MUX                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x94)))            //Attributes : RW
#define PET_PMA3_BROADCAST_LANE_REFCLK_SEL                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xA0)))            //Attributes : RW
#define PET_PMA3_BROADCAST_ETH_CLK_CTRL                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xB0)))            //Attributes : RW
#define PET_PMA3_BROADCAST_ETH_CLK_CTRL_MUX                        (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xB1)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_ADAPT_CTRL                           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC0)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_DCC_CTRL                             (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC1)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_EQ_CTRL1                             (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC2)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_EQ_CTRL2                             (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC3)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_MARGIN_CTRL                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC4)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_MARGIN_ERROR                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC5)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RECV_REQUEST_CTRL_MUX                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC6)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_COARSE_ADAPT_CTRL                    (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC8)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_COARSE_ADAPT_CTRL_MUX                (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xC9)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xCA)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TX_DIV_CLK_CTRL                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xCB)))            //Attributes : RW
#define PET_PMA3_BROADCAST_MULTI_CLK_CTRL_MUX                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xCC)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_REQ_CTRL1                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD0)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_REQ_CTRL2                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD1)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_REQ_CTRL3                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD2)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_REQ_CTRL4                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD3)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_REQ_CTRL5                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD4)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_REQ_MUX                           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD5)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_INTERFACE_CTRL                    (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD6)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_INTERFACE_MUX                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD7)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_MASTER_PLL_STATE                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD8)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TRANS_PLL_STATE                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xD9)))            //Attributes : RO
#define PET_PMA3_BROADCAST_PLL_STATE_MUX                           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xDA)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_VALID_PHY                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xDF)))            //Attributes : RO
#define PET_PMA3_BROADCAST_RX_VALID_MUX                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE0)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_SRIO_SIGDET_MUX                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE1)))            //Attributes : RW
#define PET_PMA3_BROADCAST_SRIO_DEGRADED                           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE2)))            //Attributes : RW
#define PET_PMA3_BROADCAST_SRIO_RETRAIN                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE3)))            //Attributes : RW
#define PET_PMA3_BROADCAST_SRIO_SHORT_RUN                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE4)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_INIT_C0                              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE5)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_INIT_CN1                             (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE6)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_INIT_CP1                             (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE7)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RULE_CTRL_1                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE8)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RULE_CTRL_2                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xE9)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RULE_CTRL_3                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xEA)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RULE_CTRL_4                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xEB)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_ALGORITHM_CTRL                       (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xEC)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_TX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xED)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_ADJ_INTERVAL                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xEE)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RX_REQ_CTRL                          (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xEF)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RX_TRAIN_CTRL                        (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF0)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RX_RESET_CYCLE                       (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF1)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RPCS_KTR_STATUS                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF2)))            //Attributes : RO
#define PET_PMA3_BROADCAST_EQ_FSM                                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF3)))            //Attributes : RO
#define PET_PMA3_BROADCAST_ETH_RX_LOS                              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF4)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_PRESET_C0                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF5)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_PRESET_CN1                           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF6)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_PRESET_CP1                           (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF7)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_SUCC_MASK                            (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xF8)))            //Attributes : RW
#define PET_PMA3_BROADCAST_PMA_COM_SCRATCH                         (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0xff)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x100)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x101)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x102)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x103)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x104)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x105)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x106)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x107)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_EQ_TX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x108)))            //Attributes : RW
#define PET_PMA3_BROADCAST_EQ_RX_FSM_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x109)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_EQ_RX_FSM_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x10A)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_RX_FSM_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x10B)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_EQ_RX_FSM_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x10C)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_EQ_RX_FSM_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x10D)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x110)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x111)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x112)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x113)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x114)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x115)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x116)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x117)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_TX_EQ_MAIN_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x118)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_TXMAIN_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x119)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_RX_TXMAIN_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x11A)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_RX_TXMAIN_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x11B)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_RX_TXMAIN_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x11C)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_RX_TXMAIN_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x11D)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY0                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x120)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY1                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x121)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY2                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x122)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY3                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x123)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY4                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x124)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY5                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x125)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY6                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x126)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY7                     (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x127)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_TX_EQ_POST_HISTORY_CTRL                 (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x128)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_TXPOST_DIR_HISTORY0                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x129)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_RX_TXPOST_DIR_HISTORY1                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x12A)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_RX_TXPOST_DIR_HISTORY2                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x12B)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_RX_TXPOST_DIR_HISTORY3                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x12C)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_RX_TXPOST_DIR_HISTORY_CTRL              (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x12D)))            //Attributes : RW
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY0                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x130)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY1                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x131)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY2                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x132)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY3                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x133)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY4                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x134)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY5                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x135)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY6                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x136)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY7                      (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x137)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_TX_EQ_PRE_HISTORY_CTRL                  (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x138)))            //Attributes : RW
#define PET_PMA3_BROADCAST_RX_TXPRE_DIR_HISTORY0                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x139)))            //Attributes : RO_EXT_L
#define PET_PMA3_BROADCAST_RX_TXPRE_DIR_HISTORY1                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x13A)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_RX_TXPRE_DIR_HISTORY2                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x13B)))            //Attributes : RO_EXT
#define PET_PMA3_BROADCAST_RX_TXPRE_DIR_HISTORY3                   (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x13C)))            //Attributes : RO_EXT_H
#define PET_PMA3_BROADCAST_RX_TXPRE_DIR_HISTORY_CTRL               (*((volatile uint32_t *)(PET_PMA3_BROADCAST_BASE + 4*0x13D)))            //Attributes : RW

//The PMA COMMON Register
#define PET_PMA3_MPLLA_PARAM1                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_MPLLA_PARAM2                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x01)))            //Attributes : RW
#define PET_PMA3_MPLLA_PARAM3                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x02)))            //Attributes : RW
#define PET_PMA3_MPLLA_PARAM4                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x03)))            //Attributes : RW
#define PET_PMA3_MPLLA_PARAM5                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_MPLLA_PARAM6                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_MPLLA_FORCE_EN              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_MPLLA_FORCE_ACK             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x07)))            //Attributes : RO
#define PET_PMA3_MPLLB_PARAM1                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x08)))            //Attributes : RW
#define PET_PMA3_MPLLB_PARAM2                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x09)))            //Attributes : RW
#define PET_PMA3_MPLLB_PARAM3                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x0A)))            //Attributes : RW
#define PET_PMA3_MPLLB_PARAM4                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x0B)))            //Attributes : RW
#define PET_PMA3_MPLLB_PARAM5                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x0C)))            //Attributes : RW
#define PET_PMA3_MPLLB_PARAM6                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x0D)))            //Attributes : RW
#define PET_PMA3_MPLLB_FORCE_EN              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x0E)))            //Attributes : RW
#define PET_PMA3_MPLLB_FORCE_ACK             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x0F)))            //Attributes : RO
#define PET_PMA3_SUP_MISC                    (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x16)))            //Attributes : RW
#define PET_PMA3_MPLLA_FRAC_CTRL1            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x17)))            //Attributes : RW
#define PET_PMA3_MPLLA_FRAC_CTRL2            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x18)))            //Attributes : RW
#define PET_PMA3_MPLLA_FRAC_CTRL3            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x19)))            //Attributes : RW
#define PET_PMA3_MPLLA_FRAC_CTRL4            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x1A)))            //Attributes : RW
#define PET_PMA3_MPLLA_SSC_CTRL1             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x1B)))            //Attributes : RW
#define PET_PMA3_MPLLA_SSC_CTRL2             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x1C)))            //Attributes : RW_EXT_L
#define PET_PMA3_MPLLA_SSC_CTRL3             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x1D)))            //Attributes : RW_EXT_H
#define PET_PMA3_MPLLA_SSC_CTRL4             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x1E)))            //Attributes : RW
#define PET_PMA3_MPLLA_SSC_CTRL5             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x1F)))            //Attributes : RW_EXT_L
#define PET_PMA3_MPLLA_SSC_CTRL6             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x20)))            //Attributes : RW_EXT_H
#define PET_PMA3_MPLLB_FRAC_CTRL1            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x21)))            //Attributes : RW
#define PET_PMA3_MPLLB_FRAC_CTRL2            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_MPLLB_FRAC_CTRL3            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x23)))            //Attributes : RW
#define PET_PMA3_MPLLB_FRAC_CTRL4            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x24)))            //Attributes : RW
#define PET_PMA3_MPLLB_SSC_CTRL1             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x25)))            //Attributes : RW
#define PET_PMA3_MPLLB_SSC_CTRL2             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x26)))            //Attributes : RW_EXT_L
#define PET_PMA3_MPLLB_SSC_CTRL3             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x27)))            //Attributes : RW_EXT_H
#define PET_PMA3_MPLLB_SSC_CTRL4             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x28)))            //Attributes : RW
#define PET_PMA3_MPLLB_SSC_CTRL5             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x29)))            //Attributes : RW_EXT_L
#define PET_PMA3_MPLLB_SSC_CTRL6             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x2A)))            //Attributes : RW_EXT_H
#define PET_PMA3_MPLLA_RECAL_CTRL            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x2B)))            //Attributes : RW
#define PET_PMA3_MPLLB_RECAL_CTRL            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x2C)))            //Attributes : RW
#define PET_PMA3_MPLL_CTRL_MUX               (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x2D)))            //Attributes : RW
#define PET_PMA3_POWER_SUPPLY_SEL            (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x30)))            //Attributes : RW
#define PET_PMA3_PHY_RESET                   (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x31)))            //Attributes : RW
#define PET_PMA3_REF_CLK_CTRL                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x40)))            //Attributes : RW
#define PET_PMA3_REFA_CLK_CTRL1              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x41)))            //Attributes : RW
#define PET_PMA3_REFA_CLK_CTRL2              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x42)))            //Attributes : RW
#define PET_PMA3_REFA_CLK_STATUS             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x43)))            //Attributes : RO
#define PET_PMA3_REFB_CLK_CTRL1              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x44)))            //Attributes : RW
#define PET_PMA3_REFB_CLK_CTRL2              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x45)))            //Attributes : RW
#define PET_PMA3_REFB_CLK_STATUS             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x46)))            //Attributes : RO
#define PET_PMA3_REF_CLK_MUX                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x47)))            //Attributes : RW
#define PET_PMA3_RES_ACK_IN                  (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x50)))            //Attributes : RW
#define PET_PMA3_RES_ACK_OUT                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x51)))            //Attributes : RO
#define PET_PMA3_RES_REQ_IN                  (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x52)))            //Attributes : RW
#define PET_PMA3_RES_REQ_OUT                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x53)))            //Attributes : RO
#define PET_PMA3_RTUNE_REQ                   (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x54)))            //Attributes : RW
#define PET_PMA3_RTUNE_ACK                   (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x55)))            //Attributes : RO
#define PET_PMA3_RTUNE_CTRL1                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x56)))            //Attributes : RW
#define PET_PMA3_RTUNE_CTRL2                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x57)))            //Attributes : RW
#define PET_PMA3_RTUNE_CTRL3                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x58)))            //Attributes : RW
#define PET_PMA3_RX_BIAS_CURRENT_CTRL        (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x59)))            //Attributes : RW
#define PET_PMA3_CR_PARA_SEL                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x90)))            //Attributes : RW
#define PET_PMA3_POWER_GATING_SIGNAL1        (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x60)))            //Attributes : RW
#define PET_PMA3_POWER_GATING_SIGNAL2        (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x61)))            //Attributes : RO
#define PET_PMA3_POWER_GATING_SIGNAL3        (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x62)))            //Attributes : RW
#define PET_PMA3_SRAM_CTRL                   (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x68)))            //Attributes : RW
#define PET_PMA3_SRAM_STATUS                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x69)))            //Attributes : RO
#define PET_PMA3_SRIO_RST_REQ                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x6A)))            //Attributes : RO
#define PET_PMA3_SRIO_GEN3_EN                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x6C)))            //Attributes : RW
#define PET_PMA3_SRIO_RATE_OUT               (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x6D)))            //Attributes : RW
#define PET_PMA3_CPRI_RST_REQ                (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x70)))            //Attributes : RW
#define PET_PMA3_CPRI_RX_LOS                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x71)))            //Attributes : RW
#define PET_PMA3_CPRI_SIGNAL_OK              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x72)))            //Attributes : RW
#define PET_PMA3_CPRI_ENERGY_DET             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x73)))            //Attributes : RW
#define PET_PMA3_CPRI_SIGDET                 (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x74)))            //Attributes : RW
#define PET_PMA3_CPRI_PCS_STATUS             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x75)))            //Attributes : RO
#define PET_PMA3_CPRI_PCS_STATUS_CTRL        (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x76)))            //Attributes : RW
#define PET_PMA3_ETH_ENERGY_DET              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x80)))            //Attributes : RW
#define PET_PMA3_ETH_SPEED_CTRL              (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0x81)))            //Attributes : RO
#define PET_PMA3_TX_CLK_SEL                  (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0xF0)))            //Attributes : RW
#define PET_PMA3_RPCS_TX_CLK_SEL             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0xF1)))            //Attributes : RW
#define PET_PMA3_RPCS_RX_CLK_SEL             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0xF2)))            //Attributes : RW
#define PET_PMA3_PMA_COM_SCRATCH             (*((volatile uint32_t *)(PET_PMA3_COMMON_BASE + 4*0xff)))            //Attributes : RW

//The PMA PCS Register
#define PET_PMA3_PCS_SOFT_RESET              (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x00)))            //Attributes : RW
#define PET_PMA3_PCS_LOOPBACK_CTRL           (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x04)))            //Attributes : RW
#define PET_PMA3_PCS_PRBS_UDP_SEND           (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x05)))            //Attributes : RW
#define PET_PMA3_PCS_PRBS_SEND_ERRINS        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x06)))            //Attributes : RW
#define PET_PMA3_PCS_TXUDP_0                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x07)))            //Attributes : RW_EXT_L
#define PET_PMA3_PCS_TXUDP_1                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x08)))            //Attributes : RW_EXT
#define PET_PMA3_PCS_TXUDP_2                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x09)))            //Attributes : RW_EXT
#define PET_PMA3_PCS_TXUDP_3                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x0A)))            //Attributes : RW_EXT
#define PET_PMA3_PCS_TXUDP_4                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x0B)))            //Attributes : RW_EXT_H
#define PET_PMA3_PCS_PRBS_UDP_CHK            (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x10)))            //Attributes : RW
#define PET_PMA3_PCS_RXUDP_0                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x11)))            //Attributes : RW_EXT_L
#define PET_PMA3_PCS_RXUDP_1                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x12)))            //Attributes : RW_EXT
#define PET_PMA3_PCS_RXUDP_2                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x13)))            //Attributes : RW_EXT
#define PET_PMA3_PCS_RXUDP_3                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x14)))            //Attributes : RW_EXT
#define PET_PMA3_PCS_RXUDP_4                 (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x15)))            //Attributes : RW_EXT_H
#define PET_PMA3_PCS_RXPRBS_ERRCNT_L0        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x16)))            //Attributes : RO
#define PET_PMA3_PCS_RXPRBS_ERRCNT_L1        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x17)))            //Attributes : RO
#define PET_PMA3_PCS_RXPRBS_ERRCNT_L2        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x18)))            //Attributes : RO
#define PET_PMA3_PCS_RXPRBS_ERRCNT_L3        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x19)))            //Attributes : RO
#define PET_PMA3_PCS_NELP_FIFO_STATUS        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x20)))            //Attributes : RO
#define PET_PMA3_PCS_FELP_FIFO_STATUS        (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x21)))            //Attributes : RO
#define PET_PMA3_PCS_BIT_REV_CTRL            (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0x22)))            //Attributes : RW
#define PET_PMA3_PCS_SOFT_PON_RST            (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0xfe)))            //Attributes : RW
#define PET_PMA3_PCS_PCS_SCRATCH             (*((volatile uint32_t *)(PET_PMA3_PCS_BASE + 4*0xff)))            //Attributes : RW

#endif
